SystemOrganization addCategory: #'SqSquare-Core-Event'!
SystemOrganization addCategory: #'SqSquare-Core-Event-Concrete'!
SystemOrganization addCategory: #'SqSquare-Core-Board'!
SystemOrganization addCategory: #'SqSquare-Core-Serializer'!
SystemOrganization addCategory: #'SqSquare-Core-Util'!
SystemOrganization addCategory: #'SqSquare-Core-Network-Connections'!
SystemOrganization addCategory: #'SqSquare-Core-Model'!
SystemOrganization addCategory: #'SqSquare-Core-Common'!
SystemOrganization addCategory: #'SqSquare-Core-Link'!
SystemOrganization addCategory: #'SqSquare-Core-Player'!
SystemOrganization addCategory: #'SqSquare-Core-Experimental'!
SystemOrganization addCategory: #'SqSquare-Core-Tests'!
SystemOrganization addCategory: #'SqSquare-Core-Widget'!

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/2/2006 17:13'!
asPlayer
	^CObject fromCompactBytes: self! !

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/13/2006 14:51'!
asRawBytes
	^SqUtil toByteArray: self! !

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/7/2006 11:16'!
asSnappedPlayer
	^SqProjectSerializer deserialize: self! !

ByteArray variableByteSubclass: #SqPackedBytes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqPackedBytes class methodsFor: 'examples' stamp: 'MU 2/15/2006 17:22'!
example1
	"SqPackedBytes example1"
	| form data inst |
	form _ Form fromUser.
	data _ form asCompactBytesCompressedOnDemand.
	inst _ SqPackedBytes type: #Form bytes: data.
	{data. inst} inspect! !

!SqPackedBytes class methodsFor: 'examples' stamp: 'MU 2/15/2006 17:28'!
example2
	"SqPackedBytes example2"
	| inst |
	inst _ SqPackedBytes fromObject: (Form fromUser).
	
	{inst. inst asObject} inspect! !

!SqPackedBytes class methodsFor: 'instance creation' stamp: 'MU 2/15/2006 17:23'!
fromObject: obj
	^self type: obj class name bytes: obj asCompactBytesCompressedOnDemand.! !

!SqPackedBytes class methodsFor: 'instance creation' stamp: 'MU 2/16/2006 11:53'!
type: className bytes: bytes
	| stream |
	stream _ WriteStream
				on: (ByteArray new: (bytes size + 10)).
	stream nextLittleEndianNumber: 1 put: className size.
	stream nextPutAll: className asByteArray.
	stream nextPutAll: bytes.
	^self withAll: stream contents.! !

!SqPackedBytes methodsFor: 'serialization' stamp: 'MU 2/15/2006 17:45'!
asObject
	| kls |
	kls _ Smalltalk at: self type ifAbsent: [^nil].
	^kls fromCompactBytes: self bytes uncompressOnDemand! !

!SqPackedBytes methodsFor: 'accessing' stamp: 'MU 2/15/2006 17:44'!
bytes
	| readStream size |
	readStream := self readStream.
	size := readStream nextLittleEndianNumber: 1.
	readStream skip: size.
	^ readStream upToEnd! !

!SqPackedBytes methodsFor: 'serialization' stamp: 'MU 2/15/2006 17:28'!
forReceive
	^self asObject! !

!SqPackedBytes methodsFor: 'objects from disk' stamp: 'mu 3/13/2006 15:51'!
readDataFrom: aDataStream size: varsOnDisk
	| bytes |
	aDataStream beginReference: self.

	bytes _ aDataStream next.
	"^bytes primitiveChangeClassTo: self"

	1 to: bytes size do:
		[:i | self basicAt: i put: (bytes at: i)].

	^self
	! !

!SqPackedBytes methodsFor: 'objects from disk' stamp: 'mu 3/13/2006 15:49'!
storeDataOn: aDataStream

	aDataStream
		beginInstance: self class
		size: self basicSize.

	"aDataStream nextPut: self copy asRawBytes"

	aDataStream nextPut: (ByteArray streamContents: [:str | str nextPutAll: self])! !

!SqPackedBytes methodsFor: 'accessing' stamp: 'MU 2/15/2006 17:43'!
type
	| readStream size typeBytes |
	readStream := self readStream.
	size := readStream nextLittleEndianNumber: 1.
	typeBytes := readStream next: size.
	^ typeBytes asString asSymbol! !

!CCostumeGraphic methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeGraphic methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!CCostumeBorder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeBorder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CTextLabel subclass: #SqSheetPlayer
	instanceVariableNames: 'prevContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqSheetPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="players" toSet="players:" changeEvent="playersChanged">players</field>
	<field instanceVariable="true" serializable="false" toGet="prevContents" toSet="prevContents:">prevContents</field>
</fields>'!

!SqSheetPlayer class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 11:34'!
initialize
	self registerToPartsBin! !

!SqSheetPlayer class methodsFor: 'instance creation' stamp: 'minami 3/27/2006 11:57'!
newSample
	| sample |
	sample := self new.
	sample extent: 150@150.
	^sample! !

!SqSheetPlayer class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 11:33'!
registerToPartsBin
"
	SqSheetPlayer registerToPartsBin
"
	CPartsBin
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'Sheet'
				balloonHelp: 'a player works like a paper '
				category: '-SqSquare'
				creator: SqSheetPlayer
				selector: #newbornPartToDropIn:
				customForm: nil).! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 4/3/2006 17:00'!
addPlayer: aPlayer
	| tfm |
	(self isIn: aPlayer) ifTrue: [^ aPlayer signal: #dropReject].

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.
	self add: aPlayer.

	self isRecording ifFalse: [^ self].
	self isOnAnyBoard ifFalse: [^ self].

	aPlayer hasPlayerId ifFalse: [
		aPlayer playerId: UUID new.
		self attachEventRecordBehavior: aPlayer.
		self recordCreateEventFor: aPlayer.
		self eventRecordBoard ifNotNilDo: [:b | b isHeadless ifFalse: [self waitTick]].
		self recordDefaultStatus: aPlayer.
		self attachBoardPropertiesTo: aPlayer.
		aPlayer attacheAllContentsTo: self.
	].

	aPlayer signal: #dropAccept with: self.
	self signal: #contentsChanged.

! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 4/3/2006 17:23'!
attachBoardPropertiesTo: aPlayer
	aPlayer scale: 1.
! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'minami 2/24/2006 17:20'!
attachEventRecordBehavior: aPlayer
	| behavior |
	self eventRecordBoard ifNil: [^ self].

	behavior := self eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: self eventRecordBoard.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 4/4/2006 11:51'!
attacheAllContentsTo: boardOrSheet
	| primCostume |

	primCostume := costume costume.

	primCostume contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := primCostume contents at: i.
		p :=cos player.
		p hasPlayer 
			ifFalse: [self addPlayer: p]
			ifTrue: [
				p player isComplexPlayer ifTrue: [
					self addPlayer: p player.
					p player attacheAllContentsTo: self].
			].
	].
! !

!SqSheetPlayer methodsFor: 'defaults' stamp: 'minami 2/13/2006 13:39'!
eventRecordBehaviorClass
	^ SqEventRecordBehavior! !

!SqSheetPlayer methodsFor: 'initialize' stamp: 'minami 2/8/2006 10:56'!
initialize
	super initialize.

	self autoFit: false.
	self text: 'Edit here'.

! !

!SqSheetPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 12:16'!
isComplexPlayer
	^true! !

!SqSheetPlayer methodsFor: 'testing' stamp: 'mu 3/16/2006 17:04'!
isSheet
	^true! !

!SqSheetPlayer methodsFor: 'events' stamp: 'minami 2/6/2006 15:17'!
onDragDrop: aPlayer 
	<on: dragDrop>

	self addPlayer: aPlayer.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 3/2/2006 10:49'!
onDropAccepted
	self attacheAllContentsTo: self! !

!SqSheetPlayer methodsFor: 'events' stamp: 'minami 2/8/2006 11:06'!
onMouseDrag
	| draggee |

	<on: mouseDrag>

	draggee := self findDraggablePlayerAt: self cursorPoint.
	draggee ifNotNilDo: [:d | 	^ d onDrag].

	super onMouseDrag! !

!SqSheetPlayer methodsFor: 'opening' stamp: 'minami 2/21/2006 13:36'!
open
	super open.
	self postOpen.! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/6/2006 15:18'!
players
	"Answer the players of the receiver"
	<bewareOf: #playersChanged>
	^self propertyValueAt: #players! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/6/2006 15:18'!
players: aValue
	"Modify the receiver's players"
	^self propertyValueAt: #players put: aValue with: #playersChanged! !

!SqSheetPlayer methodsFor: 'opening' stamp: 'minami 2/21/2006 13:37'!
postOpen
	self width: 100.
	self height: 100.
! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/7/2006 19:20'!
prevContents
	"Answer the prevContents of the receiver"
	^prevContents! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/7/2006 19:20'!
prevContents: aValue
	"Modify the receiver's prevContents"
	prevContents := aValue! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 3/17/2006 11:21'!
recordCreateEventFor: aPlayer
	| evt  |
	self eventRecordBoard ifNil: [^ self].

	evt := SqPlayerEventFactory
				createEvent: #playerCreated
				target: aPlayer
				accessId: self eventRecordBoard accessId
				args: #().
	self eventRecordBoard recordEvent: evt.
! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'minami 2/13/2006 15:34'!
recordDefaultStatus: aPlayer
	aPlayer signal: #geometryChanged.
	aPlayer signal: #flagsChanged.
	aPlayer signal: #fillChanged.
	aPlayer signal: #borderChanged.
	aPlayer signal: #textChanged.
	aPlayer signal: #graphicChanged.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 2/7/2006 19:20'!
setNewContents: aText
	self prevContents: aText.
	self contents: aText.
! !

!SqSheetPlayer methodsFor: 'initialize' stamp: 'minami 3/2/2006 10:51'!
setupCostume
	super setupCostume.

	self color: (Color r: 1.0 g: 1.0 b: 0.5)
	! !

!Object class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/14/2006 16:31'!
fromCompactBytes: bytes
	| rawBytes |
	rawBytes _ bytes uncompressOnDemand.
	^RmtStreamer unstream: rawBytes by: #DataStream! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/8/2006 16:21'!
asCompactBytes
	"Default is not so compact"
	^RmtStreamer stream: self 
	! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/14/2006 16:13'!
asCompactBytesCompressedOnDemand
	^self asCompactBytes compressIfMoreThan: SqSettings compressThreshold
	! !

!Object methodsFor: '*SqSquare-Core-releasing' stamp: 'MU 2/10/2006 15:04'!
destroy
	self release! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:01'!
forReceive
	^self! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:00'!
forSend
	^self! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:36'!
isAssociation
	^false! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:33'!
isAssociationCollection
	^false! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:29'!
originalClass
	^ self isUniClass
		ifTrue: [self isBehavior
				ifTrue: [| className | 
					className := (self originalClassName readStream upTo: Character space) asSymbol.
					(Smalltalk at: className) class]
				ifFalse: [Smalltalk at: self originalClassName]]
		ifFalse: [self class]! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:24'!
originalClassName
	^ ((self isUniClass)
		ifTrue: [self className copyFrom: 2 to: self className size]
		ifFalse: [self className]) asSymbol! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:41'!
originalTheNonMetaClassName
	^ (self originalClassName readStream upTo: Character space) asSymbol! !

!Object methodsFor: '*SqSquare-Core-override' stamp: 'minami 2/27/2006 04:50'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^ self printStringLimitedTo: 100000! !

!Object methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
readMementoFieldsFrom: deserializer	
	"If not player, just read self normally"
	^self readFieldsFrom: deserializer! !

!Object methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:53'!
writeMementoFieldsOn: serializer
	"If not player, just serialize self normally"
	^self writeFieldsOn: serializer! !

Object subclass: #SqAbstractConnection
	instanceVariableNames: 'connector acceptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:14'!
acceptor
	^acceptor! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:14'!
acceptor: aAcceptor 
	acceptor := aAcceptor! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'MU 3/1/2006 10:29'!
close
	connector ifNotNilDo: [:con | con close].
	acceptor ifNotNilDo: [:acc | acc close].

	connector _ acceptor _ nil

! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'mu 12/29/2005 00:33'!
connector
	^connector! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 12:02'!
connector: aConnector 
	connector := aConnector! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'mu 3/9/2006 11:14'!
deferSend: aMessage 
	self connector
		ifNotNilDo: [:con | con isConnected
				ifTrue: [con command: aMessage]
				ifFalse: [self close]]! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:13'!
handler
	^self acceptor ifNotNilDo: [:acc | acc handler].! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:13'!
handler: aBlock
	self acceptor ifNotNilDo: [:acc | acc handler: aBlock].! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'mu 12/29/2005 00:37'!
isConnected
	^self connector notNil
		and: [self connector isConnected]! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'minami 1/13/2006 10:40'!
isReady
	^ acceptor notNil
		and: [acceptor isReady]! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'minami 1/13/2006 10:40'!
isValid
	^ self isConnected and: [self isReady]! !

!SqAbstractConnection methodsFor: 'printing' stamp: 'minami 1/12/2006 13:18'!
printOn: aStream
	super printOn: aStream.
	connector ifNotNilDo: [:con | aStream nextPutAll:' connector: '; nextPutAll: con asString].
	acceptor ifNotNilDo: [:acc | aStream nextPutAll:' acceptor: '; nextPutAll: acc asString].
	! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'mu 3/9/2006 11:14'!
send: aMessage 
	self connector
		ifNotNilDo: [:con | con isConnected
				ifTrue: [con command: aMessage;
						 flush]
				ifFalse: [self close]]! !

SqAbstractConnection subclass: #SqExternalConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 3/1/2006 10:17'!
connect: ipAddressOrHost forSend: portNumber forReturn: backPort do: returnDoBlock accessId: accessId 
	| inst |
	inst := self new
				connect: ipAddressOrHost
				forSend: portNumber
				forReturn: backPort
				accessId: accessId.
	inst handler: returnDoBlock.
	^ inst! !

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 16:59'!
connect: ipAddressOrHost to: portNumber returnDo: returnDoBlock 
	"SqExternalConnection connect: 'localhost' to: 12345 returnDo: [:msg |
	Transcript cr; show: '#return: ', msg]"
	^ self
		connect: ipAddressOrHost
		to: portNumber
		returnDo: returnDoBlock
		accessId: UUID new! !

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 16:57'!
connect: ipAddressOrHost to: portNumber returnDo: returnDoBlock accessId: accessId
	"SqExternalConnection connect: 'localhost' to: 12345 returnDo: [:msg | Transcript cr; show: '#return: ', msg] "
	^ self
		connect: ipAddressOrHost
		forSend: portNumber
		forReturn: portNumber + 1
		do: returnDoBlock
		accessId: accessId! !

!SqExternalConnection class methodsFor: 'utility' stamp: 'MU 2/15/2006 18:03'!
purgeAll
	self allInstancesDo: [:each | each close]! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:25'!
acceptor
	^acceptor! !

!SqExternalConnection methodsFor: 'defaults' stamp: 'minami 1/19/2006 11:57'!
connectorClass
	^ SqConnector! !

!SqExternalConnection methodsFor: 'initialize-release' stamp: 'MU 1/20/2006 19:49'!
connect: ipAddressOrHost forSend: portNumber forReturn: backPort accessId: accessId 
	connector := self connectorClass
				connect: ipAddressOrHost
				port: portNumber
				accessId: accessId.
	acceptor := (self connectorClass
				connect: ipAddressOrHost
				port: backPort
				accessId: accessId) asAcceptor! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:40'!
handler
	^self acceptor ifNotNilDo: [:acc | acc handler].! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:40'!
handler: aBlock
	self acceptor ifNotNilDo: [:acc | acc handler: aBlock].! !

SqAbstractConnection subclass: #SqPassiveConnection
	instanceVariableNames: 'accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqPassiveConnection class
	instanceVariableNames: 'serviceForReceiveDict serviceForReturnDict incomingConnectionDict'!

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:03'!
closeAll
	"SqPassiveConnection closeAll"
	incomingConnectionDict valuesDo: [:con | con close].
	incomingConnectionDict _ Dictionary new.! !

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:03'!
closeUnconnected
	"SqPassiveConnection closeUnconnected"
	incomingConnectionDict valuesDo: [:con | con isValid ifFalse: [con close]].
	incomingConnectionDict keysAndValuesRemove: [:accessId :con | con isValid not]! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:22'!
connections
	^ incomingConnectionDict values select: [:con | con isValid].
	! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'minami 1/17/2006 11:04'!
incomingConnectionDict
	^incomingConnectionDict! !

!SqPassiveConnection class methodsFor: 'class initialization' stamp: 'minami 1/12/2006 13:26'!
initialize
	"SqPassiveConnection initialize"
	serviceForReceiveDict _ serviceForReturnDict _  nil.

	incomingConnectionDict _ Dictionary new.! !

!SqPassiveConnection class methodsFor: 'testing' stamp: 'mu 3/9/2006 16:58'!
isRunningAt: listenPortNumber
	| service |
	service _ self serviceForReceiveDict at: listenPortNumber ifAbsent: [^false].
	^service isRunning! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 1/20/2006 18:28'!
listenOn: portNumber acceptorClass: anAcceptorClass
	"SqPassiveConnection listenOn: 12345 receiveDo: [:msg | Transcript cr; show: '#received: ', msg] "
	^self listenOn: portNumber forReturn: portNumber + 1 acceptorClass: anAcceptorClass! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 3/1/2006 10:18'!
listenOn: listenPortNumber forReturn: backPortNumber acceptorClass: anAcceptorClass
	 | serviceForReceive serviceForReturn |
	serviceForReceive _  self serviceForReceiveDict at: listenPortNumber ifAbsentPut: [
		((SqTcpService on: listenPortNumber) acceptorClass: anAcceptorClass) 
	].
	serviceForReceive start.

	serviceForReturn _ self serviceForReturnDict at: backPortNumber ifAbsentPut: [
	 	((SqTcpService on: backPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReturn start.

	serviceForReceive 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst acceptor: newAcc.
	].

	serviceForReturn 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst connector: newAcc asConnector.
	]
! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 3/1/2006 10:18'!
listenOn: listenPortNumber forReturn: backPortNumber do: aBlock
	 | serviceForReceive serviceForReturn |
	serviceForReceive _  self serviceForReceiveDict at: listenPortNumber ifAbsentPut: [
		((SqTcpService on: listenPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReceive start.

	serviceForReturn _ self serviceForReturnDict at: backPortNumber ifAbsentPut: [
	 	((SqTcpService on: backPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReturn start.

	serviceForReceive 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			newAcc handler: [:msg | aBlock value: msg].
			inst acceptor: newAcc.
	].

	serviceForReturn 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst connector: newAcc asConnector.
	]
! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'mu 12/29/2005 00:43'!
listenOn: portNumber receiveDo: receivedDoBlock 
	"SqPassiveConnection listenOn: 12345 receiveDo: [:msg | Transcript cr; show: '#received: ', msg] "
	^self listenOn: portNumber forReturn: portNumber + 1 do: receivedDoBlock! !

!SqPassiveConnection class methodsFor: 'utility' stamp: 'MU 2/15/2006 18:04'!
purgeAll
	self allInstancesDo: [:each | each close]! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:56'!
serviceForReceiveDict
	serviceForReceiveDict ifNil: [serviceForReceiveDict _ Dictionary new].
	^serviceForReceiveDict! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:57'!
serviceForReturnDict
	serviceForReturnDict ifNil: [serviceForReturnDict _ Dictionary new].
	^serviceForReturnDict! !

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:04'!
stopListening
	self serviceForReceiveDict valuesDo: [:each | each stop].
	self serviceForReturnDict valuesDo: [:each | each stop].

	self closeAll.

	self initialize! !

!SqPassiveConnection class methodsFor: 'instance creation' stamp: 'minami 1/13/2006 14:14'!
with: aSqAccessId 
	^ self new accessId: aSqAccessId;
		 yourself! !

!SqPassiveConnection methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:18'!
accessId
	^ accessId! !

!SqPassiveConnection methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:18'!
accessId: aSqAccessId
	accessId _ aSqAccessId! !

Object subclass: #SqAccessId
	instanceVariableNames: 'userId imageId boardId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqAccessId class methodsFor: 'instance creation' stamp: 'minami 1/13/2006 14:08'!
userId: userName imageId: uuid 
	^ self new userId: userName;
		 imageId: uuid;
		 yourself! !

!SqAccessId class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 15:16'!
userId: userName imageId: imageUUID boardId: boardUUID
	^ self new userId: userName;
		 imageId: imageUUID;
		 boardId: boardUUID;
		 yourself! !

!SqAccessId methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:15'!
boardId
	^ boardId! !

!SqAccessId methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:15'!
boardId: uuid
	boardId _ uuid! !

!SqAccessId methodsFor: 'comparing' stamp: 'minami 1/23/2006 10:31'!
hash
	^ (self userId hash bitXor: self imageId hash) bitXor: self boardId hash! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:53'!
imageId
	^ imageId! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:54'!
imageId: uuid
	imageId _ uuid! !

!SqAccessId methodsFor: 'printing' stamp: 'minami 1/13/2006 14:40'!
printOn: aStream
	aStream nextPutAll: '[' , self userId asString.
	aStream nextPut: $@.
	aStream nextPutAll: self imageId asString, ']'.! !

!SqAccessId methodsFor: 'serialization' stamp: 'minami 3/17/2006 17:26'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.


	userId _ aDataStream next.
	boardId _ (aDataStream next ifNotNilDo: [:str | str asUUID]).
	imageId _ (aDataStream next ifNotNilDo: [:str | str asUUID]).

	! !

!SqAccessId methodsFor: 'serialization' stamp: 'mu 3/8/2006 17:04'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 3.
	aDataStream nextPut: userId asString.
	aDataStream nextPut: boardId asString.
	aDataStream nextPut: imageId asString.
	! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:53'!
userId
	^ userId! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:55'!
userId: aString
	userId _ aString! !

!SqAccessId methodsFor: 'comparing' stamp: 'MU 2/6/2006 16:24'!
= other 
	self class = other class ifFalse: [^false].

	^ self userId = other userId
		and: [self imageId = other imageId]
		and: [self boardId = other boardId]! !

Object subclass: #SqAuthentication
	instanceVariableNames: 'timeStamp role userName userId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqAuthentication class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 11:51'!
userId: str
	^self new userId: str! !

!SqAuthentication methodsFor: 'initialize-release' stamp: 'mu 10/20/2005 22:48'!
initialize
	timeStamp _ DateAndTime current! !

!SqAuthentication methodsFor: 'testing' stamp: 'mu 12/14/2005 19:56'!
isAdmin
	^self role == #administrator! !

!SqAuthentication methodsFor: 'printing' stamp: 'minami 1/26/2006 17:25'!
printOn: aStream
	aStream nextPutAll: 'auth'.
	aStream nextPut: $[.
	aStream nextPutAll: self userId.
	aStream nextPut: $]! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 19:53'!
role
	^ role.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 19:53'!
role: anObject
	role := anObject.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 15:33'!
timeStamp
	^timeStamp! !

!SqAuthentication methodsFor: 'accessing' stamp: 'MU 1/24/2006 11:45'!
userId
	^ userId.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'MU 1/24/2006 11:51'!
userId: str
	userId := str.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/15/2005 20:04'!
userName
	userName ifNil: [userName _ ''].
	^ userName.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/15/2005 20:01'!
userName: aString
	^ userName _ aString
! !

Object subclass: #SqCSVLineParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqCSVLineParser class methodsFor: 'examples' stamp: 'mu 1/11/2006 12:04'!
ex01
"
	self ex01
"

	| parser aString |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.

	parser := SqCSVLineParser new.
	^ parser parse: aString.! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'mu 1/11/2006 12:04'!
ex02
"
	self ex02
"

	| parser aString |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.

	parser := SqCSVLineParser new.
	^ parser parse: aString ignoreSize: 1.! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:47'!
ex03
"
	self ex03
"

	| parser aString headers |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.
	headers := #(AA BB CC DD).

	parser := self new.
	^ parser parse: aString headers: headers.
! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:47'!
ex04
"
	self ex04
"

	| parser aString headers |
	aString := 'aaa,bbb,ccc,ddd'.
	headers := #(BB CC DD).

	parser := self new.
	^ parser parse: aString ignoreSize: 1 headers: headers
! !

!SqCSVLineParser methodsFor: 'parse' stamp: 'minami 6/12/2005 21:06'!
parse: aString 
	^ self parse: aString ignoreSize: 0! !

!SqCSVLineParser methodsFor: 'util' stamp: 'minami 6/12/2005 21:07'!
parse: aString headers: headers
	^ self parse: aString ignoreSize: 0 headers: headers! !

!SqCSVLineParser methodsFor: 'parse' stamp: 'minami 6/12/2005 20:26'!
parse: aString ignoreSize: ignoreSize

	| wordStream words comma quota notDelimitter readStream |
	comma := $,.
	quota := $".
	words := OrderedCollection new.
	readStream := aString readStream.
	wordStream := '' writeStream.

	notDelimitter := true.
	[readStream atEnd] whileFalse: [
		| char | 
		char := readStream next.
		char == quota
			ifTrue: [notDelimitter := notDelimitter not]
			ifFalse: [(notDelimitter and: [char == comma])
						ifTrue: [
							wordStream close.
							words add: wordStream contents.
							wordStream := '' writeStream]
						ifFalse: [wordStream nextPut: char]]].
	wordStream close.
	words add: wordStream contents.
	readStream close.

	^ words allButFirst: ignoreSize! !

!SqCSVLineParser methodsFor: 'util' stamp: 'minami 6/12/2005 21:08'!
parse: aString ignoreSize: ignoreSize headers: headers
	| words dic |
	words := self parse: aString ignoreSize: ignoreSize.

	dic := Dictionary new.
	words with: headers do: [:word :header | dic at: header put: word].
	^ dic! !

Object subclass: #SqCSVParser
	instanceVariableNames: 'lineParser fromStream headerSize horizontalHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqCSVParser class methodsFor: 'constants' stamp: 'minami 6/13/2005 01:38'!
defaultConverter
	^ ShiftJISTextConverter new! !

!SqCSVParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:51'!
ex01
"
	self ex01
"

	| csv fromStream parser |
	csv := 'headA,headB,headC
1,aaa,"aaa,bbb,ccc"
2,bbb,"bbb,ccc,ddd"
3,ccc,"ccc,ddd,eee"
'.
	fromStream := csv readStream.
	parser := self parseStream: fromStream headerSize: 0@1.

	^ parser records 
	! !

!SqCSVParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:52'!
ex02
"
	self ex02
"

	| csv fromStream parser |
	csv := 'headA,headB,headC
1,aaa,"aaa,bbb,ccc"
2,bbb,"bbb,ccc,ddd"
3,ccc,"ccc,ddd,eee"
'.
	fromStream := csv readStream.
	parser := self parseStream: fromStream headerSize: 0@1.

	^ parser recordDics 
	! !

!SqCSVParser class methodsFor: 'util' stamp: 'minami 6/13/2005 01:57'!
fromFile: filePath headerSize: aPoint 
	| fs |
	fs := FileDirectory default readOnlyFileNamed: filePath.
	(fs respondsTo: #converter:) ifTrue: [ fs converter: self defaultConverter].
	^ self parseStream: fs headerSize: aPoint! !

!SqCSVParser class methodsFor: 'instance creation' stamp: 'minami 6/13/2005 01:58'!
parseStream: aStream headerSize: aPoint 
	^ self basicNew initialize; 
		setFromStream: aStream; 
		setHeaderSize: aPoint; 
		yourself! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 11/25/2005 16:56'!
closeStream
	(fromStream respondsTo: #close) ifTrue: [fromStream close].
	fromStream := nil.! !

!SqCSVParser methodsFor: 'factory' stamp: 'mu 1/11/2006 12:04'!
defaultLineParserClass
	^ SqCSVLineParser ! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 20:05'!
fromStream
	^ fromStream! !

!SqCSVParser methodsFor: 'testing' stamp: 'minami 6/12/2005 22:26'!
hasHorizontalHeader
	^ self headerSize y > 0! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 20:05'!
headerSize
	^ headerSize! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 21:12'!
horizontalHeaders
	^ horizontalHeaders! !

!SqCSVParser methodsFor: 'initialize-release' stamp: 'minami 6/13/2005 01:11'!
initialize
	lineParser := self defaultLineParserClass new.
! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 19:45'!
lineParser
	^ lineParser! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 20:14'!
nextLineOrNil
	| line |
	^ self fromStream atEnd
		ifFalse: [
			line := self fromStream upTo: Character cr.
			line copyWithout: Character lf]! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
privProcess: aBlock
	| line ignoreSize resultCol |
	self resetFromStream.
	self resetHorizontalHeaders.

	ignoreSize := self headerSize x.

	self hasHorizontalHeader ifTrue: [
		line := self nextLineOrNil.
		(line notNil and: [line notEmpty]) ifTrue: [
			self setHorizontalHeaders: (self lineParser parse: line ignoreSize: ignoreSize).
		].
	].

	resultCol := OrderedCollection new.
	[(line := self nextLineOrNil) notNil and: [line notEmpty]] whileTrue: [
		resultCol add: (aBlock value: line value: ignoreSize).
	].

	^ resultCol! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
recordDics
	^ self privProcess: [:line :ignoreSize | 
						self lineParser
							parse: line
							ignoreSize: ignoreSize
							headers: self horizontalHeaders]! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
records
	^ self privProcess: [:line :ignoreSize | self lineParser parse: line ignoreSize: ignoreSize]! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/13/2005 01:10'!
resetFromStream
	self fromStream reset! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/13/2005 01:11'!
resetHorizontalHeaders
	horizontalHeaders := nil! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 21:32'!
setFromStream: aStream
	fromStream := aStream! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 19:53'!
setHeaderSize: aPoint
	headerSize := aPoint! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 22:31'!
setHorizontalHeaders: aCollection
	horizontalHeaders := aCollection! !

Object subclass: #SqDomainModel
	instanceVariableNames: 'id name updatedTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqDomainModel class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:10'!
id: id
	^self new id: id! !

!SqDomainModel class methodsFor: 'instance creation' stamp: 'MU 2/22/2006 12:21'!
id: id name: nameStr 
	^ self new id: id;
		 name: nameStr;
		 yourself! !

!SqDomainModel methodsFor: 'actions' stamp: 'MU 2/21/2006 15:07'!
computeUpdatedTime
	updatedTime := TimeStamp now! !

!SqDomainModel methodsFor: 'comparing' stamp: 'MU 2/21/2006 15:18'!
hash
	^self id hash! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
id
	id ifNil: [id := UUID new asString readStream upTo: $-].
	^id! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
id: aString
	id _ aString! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:08'!
initialize
	self computeUpdatedTime ! !

!SqDomainModel methodsFor: 'testing' stamp: 'MU 2/22/2006 12:22'!
isGroup
	^false! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:12'!
name
	name ifNil: [^self id asString].
	^name! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:12'!
name: aString
	name _ aString! !

!SqDomainModel methodsFor: 'printing' stamp: 'MU 2/22/2006 12:20'!
printDetailsOn: aStream 
	self name isEmptyOrNil
		ifFalse: [aStream nextPutAll: self name]! !

!SqDomainModel methodsFor: 'printing' stamp: 'MU 2/22/2006 12:20'!
printOn: aStream 
	aStream nextPutAll: 'a ', self className.
	aStream nextPutAll: '( '.
	self printDetailsOn: aStream .
	aStream nextPutAll: ' )'! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:07'!
release
	! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:07'!
releaseForStore
	self computeUpdatedTime.
	! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
updatedTime

	^updatedTime! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
updatedTime: aValue

	updatedTime := aValue! !

!SqDomainModel methodsFor: 'comparing' stamp: 'MU 2/21/2006 15:16'!
= other
	^self id = other id! !

SqDomainModel subclass: #SqGroup
	instanceVariableNames: 'members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

SqGroup subclass: #SqBoard
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:08'!
boardId
	^ self id! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardId: anUUID 
	self id: anUUID! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardName
	^ self name! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardName: nameStr 
	self name: nameStr! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:12'!
description
	^description! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:12'!
description: aString
	description _ aString! !

!SqBoard methodsFor: 'printing' stamp: 'minami 1/23/2006 10:42'!
printOn: aStream
	aStream nextPut: $[. 
	aStream nextPutAll: self boardName asString, '@', self boardId asString.
	aStream nextPut: $].! !

!SqGroup methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:18'!
addMember: aMember
	self members add: aMember! !

!SqGroup methodsFor: 'testing' stamp: 'MU 2/22/2006 12:22'!
isGroup
	^true! !

!SqGroup methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:18'!
members
	members ifNil: [members _ Set new].
	^members! !

!SqGroup methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:18'!
removeMember: aMember
	self members remove: aMember! !

!SqGroup methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:19'!
removeMember: aMember ifAbsent: aBlock
	self members remove: aMember ifAbsent: aBlock! !

SqDomainModel subclass: #SqRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

SqRole class
	instanceVariableNames: 'roles'!

!SqRole class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:20'!
admin
	^ self roleAt: #admin! !

!SqRole class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:21'!
leader
	^ self roleAt: #leader! !

!SqRole class methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:20'!
roleAt: id
	^ self roles
		at: id
		ifAbsentPut: [self id: id]! !

!SqRole class methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:19'!
roles
	roles ifNil: [roles _ IdentityDictionary new].
	^roles! !

!SqRole class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:21'!
user
	^self roleAt: #user! !

SqDomainModel subclass: #SqUser
	instanceVariableNames: 'password role email male birthday'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqUser class methodsFor: 'instance creation' stamp: 'MU 2/22/2006 12:10'!
adminId: id
	^(self id: id) isAdmin: true! !

!SqUser class methodsFor: 'instance creation' stamp: 'MU 2/22/2006 12:10'!
id: id password: passwd 
	^ self new id: id;
		 password: passwd! !

!SqUser methodsFor: 'actions' stamp: 'mu 8/18/2005 22:05'!
age
	^self birthday isNil
		ifFalse: [ (Date today subtractDate: self birthday) // 365 ]
		ifTrue: [ String new ]! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
birthday
	^birthday! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
birthday: anObject
	birthday := anObject! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 21:42'!
email
	^email! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:07'!
email: aString
	email _ aString! !

!SqUser methodsFor: 'actions' stamp: 'mu 8/18/2005 22:07'!
female
	^self male not! !

!SqUser methodsFor: 'initialize-release' stamp: 'MU 2/22/2006 16:47'!
initialize
	super initialize.
	role _ SqRole user.
	email := ''.
	authenticated _ false.! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:27'!
isAdmin
	^self role = SqRole admin! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:29'!
isAdmin: aBoolean 
	role := aBoolean
				ifTrue: [SqRole admin]
				ifFalse: [SqRole user]! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:29'!
isLeader
	^self role = SqRole leader! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:29'!
isLeader: aBoolean 
	role := aBoolean
				ifTrue: [SqRole leader]
				ifFalse: [SqRole user]! !

!SqUser methodsFor: 'accessing' stamp: 'mu 12/13/2005 20:09'!
male
	male ifNil: [male _ true].
	^male! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
male: aBoolean
	male := aBoolean! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/24/2005 23:25'!
password
	^password! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/24/2005 23:25'!
password: aString
	password _ aString! !

!SqUser methodsFor: 'printing' stamp: 'mu 12/13/2005 19:45'!
printOn: aStream 
	self isAdmin
		ifTrue: [aStream nextPutAll: '[admin] '].
	self name isEmptyOrNil
		ifFalse: [aStream nextPutAll: self name]! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:03'!
role
	^role! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:03'!
role: aRole
	role _ aRole! !

Object subclass: #SqEvent
	instanceVariableNames: 'target targetId args timeStamp eventId undoArgs accessId millisecondsStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

SqEvent subclass: #SqBorderChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqBorderChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#borderColor #borderWidth #borderStyle)	! !

!SqBorderChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:08'!
type
	^ #borderChanged! !

SqEvent subclass: #SqDropAcceptEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqDropAcceptEvent methodsFor: 'actions' stamp: 'minami 2/16/2006 14:48'!
execute: board
	| targetPlayer distPlayer |
	targetPlayer := self findPlayerByUUID: self targetId on: board.
	targetPlayer ifNil: [^ self].

	distPlayer := self findPlayerByUUID: (self argsAt: #distPlayer) on: board.
	distPlayer ifNil: [distPlayer := board].


	targetPlayer stopRecordingWhile: [
		distPlayer addPlayer: targetPlayer.
		board isHeadless ifFalse: [self waitTick]. 
		targetPlayer position: (self argsAt: #targetPosition)
	].
! !

!SqDropAcceptEvent methodsFor: 'properties' stamp: 'minami 2/16/2006 12:35'!
saveProperties: aPlayer withArgs: anArray 
	| distPlayer |
	super saveProperties: aPlayer withArgs: anArray.

	self argsAt: #targetPosition put: aPlayer position.

	anArray isEmpty ifTrue: [^ self].
	distPlayer := anArray first.
	self argsAt: #distPlayer put: distPlayer playerId.
! !

!SqDropAcceptEvent methodsFor: 'defaults' stamp: 'minami 2/9/2006 16:35'!
type
	^ #dropAccept! !

!SqEvent class methodsFor: 'testing' stamp: 'mu 3/17/2006 11:29'!
isCommand
	^false! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:53'!
accessId
	^ accessId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:53'!
accessId: aSqAccessId
	accessId := aSqAccessId! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
argsAt: key
	^ self arguments at: key ifAbsent: []! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
argsAt: key put: value
	^ self arguments at: key put: value! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
arguments
	args ifNil: [args := Dictionary new].
	^ args! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:52'!
arguments: arguments
	args := arguments! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:54'!
boardId
	^ self accessId boardId! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 15:40'!
defaultEnabledPropertyNames
	^ #()! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #()! !

!SqEvent methodsFor: 'save/load' stamp: 'MU 2/16/2006 15:46'!
enabledPropertyNames
	self target ifNil: [^self defaultEnabledPropertyNames].
	
	^ self target wantsReturnEnabledPropertyNames
		ifTrue: [self target enabledPropertyNamesFor: self]
		ifFalse: [self defaultEnabledPropertyNames]! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/20/2005 11:04'!
eventId
	^ eventId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/20/2005 11:04'!
eventId: anInteger
	eventId := anInteger! !

!SqEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:13'!
execute: board
	| player |
	player := self findPlayerByUUID: self targetId on: board.
	player ifNil: [^ nil].

	player stopRecordingWhile: [
		self saveUndoProperties: player.

		(board isRecovering or: [self accessId ~= board accessId]) ifTrue: [
			self loadProperties: player.
		].
	
		board isHeadless ifFalse: [self waitTick].
	].! !

!SqEvent methodsFor: 'query' stamp: 'minami 2/9/2006 15:42'!
findPlayerByUUID: uuid on: board
	^ board findPlayerByUUID: uuid
! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 3/13/2006 11:57'!
forSend
	target _ nil.
	millisecondsStamp _ nil! !

!SqEvent methodsFor: 'comparing' stamp: 'mu 3/17/2006 12:53'!
hash
	^ (self type hash bitXor: self targetId hash) bitXor: self arguments hash
! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/6/2006 14:56'!
imageId
	^ self accessId imageId! !

!SqEvent methodsFor: 'testing' stamp: 'mu 3/17/2006 11:31'!
isCommand
	^self class isCommand! !

!SqEvent methodsFor: 'testing' stamp: 'MU 2/9/2006 16:20'!
isOnTheSameBoard: board
	^self boardId = board boardId! !

!SqEvent methodsFor: 'save/load' stamp: 'mu 3/17/2006 12:54'!
loadProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := self argsAt: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		| value |
		value := self argsAt: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
	].

	aPlayer
		perform: self loadSelector 
		with: self arguments 
		with: #().
! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:35'!
loadSelector
	^ ('loadOn', self type capitalized , 'From:withArgs:') asSymbol


! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:41'!
loadUndoProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := self undoArgs at: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		| value |
		value := self undoArgs at: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
	].

	aPlayer
		perform: self loadSelector 
		with: self undoArgs 
		with: #().
! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:32'!
millisecondsFromCurrent
	^(Time millisecondClockValue -  self millisecondsStamp) abs! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:13'!
millisecondsStamp
	millisecondsStamp ifNil: [millisecondsStamp _ Time millisecondClockValue].
	^millisecondsStamp! !

!SqEvent methodsFor: 'printing' stamp: 'minami 12/20/2005 11:04'!
printOn: aStream
	aStream nextPutAll: '['.
	aStream nextPutAll: '#', self eventId printString, ': '.
	aStream nextPutAll: self timeStamp printString, ': '.
	aStream nextPutAll: self type.
	aStream nextPutAll: ']'.! !

!SqEvent methodsFor: 'save/load' stamp: 'MU 2/16/2006 15:37'!
propertyNames
	self target ifNil: [^ self defaultPropertyNames].

	^ self target wantsReturnPropertyNames
		ifTrue: [self target propertyNamesFor: self]
		ifFalse: [self defaultPropertyNames]! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 3/17/2006 11:35'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.

	target _ aDataStream next.
	targetId _ (aDataStream next ifNotNilDo: [:str | str asUUID]).
	args _ aDataStream next.
	timeStamp _ aDataStream next.
	eventId _ aDataStream next.	
	accessId _ aDataStream next.

	

	
	
	! !

!SqEvent methodsFor: 'save/load' stamp: 'mu 3/17/2006 12:55'!
saveProperties: aPlayer withArgs: anArray
	aPlayer ifNil: [^self].

	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := aPlayer saveProperty: nameSymbol into: self arguments. 
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		aPlayer saveProperty: nameSymbol into: self arguments. 
	].

	aPlayer
		perform: self saveSelector 
		with: self arguments 
		with: anArray.
! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:36'!
saveSelector
	^ ('saveOn', self type capitalized, 'Into:withArgs:') asSymbol


! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:42'!
saveUndoProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := aPlayer saveProperty: nameSymbol into: self undoArgs. 
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		aPlayer saveProperty: nameSymbol into: self undoArgs. 
	].

	aPlayer
		perform: self saveSelector 
		with: self undoArgs 
		with: #().
! !

!SqEvent methodsFor: 'debugging' stamp: 'mu 3/9/2006 11:02'!
serializedSize
	"only for debug"
	^(RmtStreamer stream: self) size! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:14'!
setMillisecondsStamp
	millisecondsStamp _ Time millisecondClockValue! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:13'!
setTimeStamp
	timeStamp := TimeStamp current.
	! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 3/17/2006 11:35'!
storeDataOn: aDataStream
	"target targetId args timeStamp eventId undoArgs accessId"

	aDataStream
		beginInstance: self class
		size: self class instSize.

	aDataStream nextPut: target.
	aDataStream nextPut: targetId asString.
	aDataStream nextPut: args.
	aDataStream nextPut: timeStamp.
	aDataStream nextPut: eventId.	
	aDataStream nextPut: accessId.

	
	! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 12:42'!
target

	^ target
! !

!SqEvent methodsFor: 'accessing' stamp: 'MU 2/16/2006 12:08'!
targetId
	^ targetId! !

!SqEvent methodsFor: 'accessing' stamp: 'MU 2/16/2006 16:56'!
targetId: uuid
	targetId := uuid.
	self argsAt: #playerId put: uuid! !

!SqEvent methodsFor: 'accessing' stamp: 'MU 2/16/2006 13:16'!
target: player 
	player isPlayer ifFalse: [^self].
	target := player.
	self targetId: target playerId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/19/2005 16:51'!
timeStamp
	^ timeStamp! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:27'!
type
	"self subclassResponsibility "

	"Default uses reflection - override for performance"
	| nm |
	nm _ self class name.
	^ (nm copyFrom: 3 to: ((nm size - 5) max: 4)) withFirstCharacterDownshifted
	
	! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 12:25'!
undoArgs
	undoArgs ifNil: [undoArgs := Dictionary new].
	^ undoArgs ! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 15:48'!
undoArgsAt: key
	^ self undoArgs at: key ifAbsent: []! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/17/2006 08:41'!
undoArgsAt: key put: value
	^ self undoArgs at: key put: value! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/22/2005 15:32'!
undoArgs: dic
	undoArgs := dic! !

!SqEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:13'!
undo: board
	| player |
	player := self findPlayerByUUID: self targetId on: board.
	player ifNil: [^ nil].

	self loadUndoProperties: player.

! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:54'!
userId
	^ self accessId userId! !

!SqEvent methodsFor: 'comparing' stamp: 'mu 3/1/2006 16:33'!
= aEventRecord
	self type == aEventRecord type ifFalse: [^ false].
	self targetId == aEventRecord targetId ifFalse: [^ false].
	self accessId = aEventRecord accessId ifFalse: [^ false].
	self eventId == aEventRecord eventId ifFalse: [^ false].

"	self args = aEventRecord args ifFalse: [^ false]."

	^ true! !

SqEvent subclass: #SqFillChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqFillChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#color #fillAlpha #fillAngle #fillColor #fillColors #fillOffset #fillStyle)	! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/9/2006 16:56'!
loadProperties: aPlayer
	super loadProperties: aPlayer.

	aPlayer color: (aPlayer color alpha: (self argsAt: #alpha)).! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/3/2006 17:08'!
loadUndoProperties: aPlayer
	super loadUndoProperties: aPlayer.

	aPlayer color: (aPlayer color: (self undoArgs at: #alpha)).! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/16/2006 12:33'!
saveProperties: aPlayer withArgs: anArray
	super saveProperties: aPlayer withArgs: anArray.

	self argsAt: #alpha put: aPlayer color alpha.! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/3/2006 17:05'!
saveUndoProperties: aPlayer
	super saveUndoProperties: aPlayer.

	self undoArgs at: #alpha put: aPlayer color alpha.! !

!SqFillChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:08'!
type
	^ #fillChanged! !

SqEvent subclass: #SqFlagsChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqFlagsChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#clipping #floating #infinite #locked #sticky #userDraw #visible)	! !

!SqFlagsChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #flagsChanged! !

SqEvent subclass: #SqGenericCommand
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

!SqGenericCommand class methodsFor: 'instance creation' stamp: 'mu 3/17/2006 11:44'!
accessId: aid selector: selector arguments: args
	"SqGenericCommand accessId: nil selector: #test: arguments: #(a)"
	^self new
		accessId: aid;	
		selector: selector;
		arguments: args
		! !

!SqGenericCommand class methodsFor: 'instance creation' stamp: 'mu 3/27/2006 14:53'!
accessId: aid targetId: id selector: selector arguments: args
	"SqGenericCommand accessId: nil targetId: UUID new selector: #test: arguments: #(a)"
	^self new
		accessId: aid;
		targetId: id;
		selector: selector;
		arguments: args
		! !

!SqGenericCommand class methodsFor: 'testing' stamp: 'mu 3/17/2006 11:28'!
isCommand
	^true! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:56'!
arguments
	args ifNil: [args := #()].
	^ args! !

!SqGenericCommand methodsFor: 'actions' stamp: 'mu 3/17/2006 12:52'!
execute: board
	"By default, just use board as perform:''s target "
	board perform: self selector withArguments: self arguments! !

!SqGenericCommand methodsFor: 'serializing' stamp: 'mu 3/17/2006 12:29'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.
	
	targetId _ (aDataStream next ifNil: [nil] ifNotNilDo: [:str | str asUUID]).
	args _ aDataStream next.
	timeStamp _ aDataStream next.
	eventId _ aDataStream next.	
	accessId _ aDataStream next.
	selector _ aDataStream next.! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 11:31'!
selector
	^selector! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 11:31'!
selector: aSymbol
	selector _ aSymbol! !

!SqGenericCommand methodsFor: 'serializing' stamp: 'mu 3/17/2006 12:30'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 6.
	
	aDataStream nextPut: (targetId ifNil: [] ifNotNilDo: [:tid | tid asString]).
	aDataStream nextPut: args.
	aDataStream nextPut: timeStamp.
	aDataStream nextPut: eventId.	
	aDataStream nextPut: accessId.
	aDataStream nextPut: selector.
! !

!SqGenericCommand methodsFor: 'defaults' stamp: 'mu 3/17/2006 11:26'!
type
	^ #genericCommand! !

!SqGenericCommand methodsFor: 'actions' stamp: 'mu 3/17/2006 12:50'!
undo: board
	"not supported - you have to subclass me"! !

SqEvent subclass: #SqGeometryChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqGeometryChangedEvent methodsFor: 'defaults' stamp: 'minami 2/20/2006 16:18'!
defaultPropertyNames
	^ #(#nose #scale #aspectRatio #position #extent #direction #nose)	! !

!SqGeometryChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:10'!
type
	^ #geometryChanged! !

SqEvent subclass: #SqGraphicChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 15:41'!
defaultEnabledPropertyNames
	^ #(#graphicEnabled )! !

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#graphicAnchorPoint #graphicFit #graphicOffset #graphicForm)	! !

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #graphicChanged! !

SqEvent subclass: #SqImageChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqImageChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#image)	! !

!SqImageChangedEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:27'!
type
	^ #imageChanged! !

SqEvent subclass: #SqLabelChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqLabelChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#label)	! !

!SqLabelChangedEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:00'!
type
	^ #labelChanged! !

SqEvent subclass: #SqPlayerCreatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerCreatedEvent methodsFor: 'actions' stamp: 'minami 3/2/2006 11:31'!
execute: board
	| aPlayer behavior className |
self flag: #minami. "undo?"

	(self findPlayerByUUID: self targetId on: board) ifNotNil: [^ nil].

	className _ self argsAt: #class.

	aPlayer := (self argsAt: #playerBytes) 
			ifNil: [(Smalltalk at: className asSymbol ifAbsent: [CValuePlayer]) new] 
			ifNotNilDo: [:bytes | bytes asPlayer].	

	"aPlayer := (Smalltalk at: (self argsAt: #class)) new."
	
	board isHeadless ifFalse: [self waitTick]. 

	self saveUndoProperties: aPlayer.
	self loadProperties: aPlayer.

	behavior := board eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: board.

	board add: aPlayer.
	board isHeadless ifFalse: [self waitTick].! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/17/2006 14:14'!
loadProperties: aPlayer
	aPlayer playerId: self targetId.

	aPlayer graphicEnabled: (self argsAt: #graphicEnabled).
	aPlayer textEnabled: (self argsAt: #textEnabled).
	aPlayer graphicForm: (self argsAt: #graphicForm).
	(self arguments includesKey: #graphicFit) ifTrue: [
		aPlayer graphicFit: (self argsAt: #graphicFit).
	].
	aPlayer extent: (self argsAt: #extent).
	aPlayer position: (self argsAt: #position).
	aPlayer nose: (self argsAt: #nose).

	aPlayer
		perform: self loadSelector 
		with: self arguments 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'minami 12/26/2005 14:48'!
loadUndoProperties: aPlayer
	"do nothing"! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/17/2006 12:54'!
saveProperties: aPlayer withArgs: anArray

	aPlayer isUniClass 
		ifTrue: [self argsAt: #playerBytes put: aPlayer asCompactBytes].

	self argsAt: #class put: aPlayer className. 

	self argsAt: #position put: aPlayer position.
	self argsAt: #extent put: aPlayer extent.
	self argsAt: #nose put: aPlayer nose.

	self argsAt: #textEnabled put: aPlayer textEnabled.
	self argsAt: #graphicEnabled put: aPlayer graphicEnabled.
	self argsAt: #graphicForm put: aPlayer graphicForm.
	aPlayer graphicEnabled ifTrue: [
		self argsAt: #graphicFit put: aPlayer graphicFit
	].

	aPlayer
		perform: self saveSelector 
		with: self arguments 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/1/2006 17:16'!
saveUndoProperties: aPlayer

	aPlayer isUniClass 
		ifTrue: [self undoArgsAt: #playerBytes put: aPlayer asCompactBytes].

	self undoArgsAt: #class put: aPlayer className.

	self undoArgsAt: #position put: aPlayer position. 
	self undoArgsAt: #extent put: aPlayer extent.
	self undoArgsAt: #nose put: aPlayer nose.

	self undoArgsAt: #textEnabled put: aPlayer textEnabled.
	self undoArgsAt: #graphicEnabled put: aPlayer graphicEnabled.
	self undoArgsAt: #graphicForm put: aPlayer graphicForm.
	aPlayer graphicEnabled ifTrue: [
		self undoArgsAt: #graphicFit put: aPlayer graphicFit
	].

	aPlayer
		perform: self saveSelector 
		with: self undoArgs 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 10:59'!
type
	^ #playerCreated! !

!SqPlayerCreatedEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:14'!
undo: board
	| player |
	player := self findPlayerByUUID: self targetId on: board.
	player ifNil: [^ nil].

	player destroy! !

SqEvent subclass: #SqPlayerLockEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerLockEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:14'!
execute: board
	board isRecovering ifTrue: [^self].
	board freezePlayer: self targetId from: self userId! !

!SqPlayerLockEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:05'!
type
	^ #lock! !

!SqPlayerLockEvent methodsFor: 'actions' stamp: 'minami 2/9/2006 11:58'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqPlayerRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerRemovedEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:14'!
execute: board
	| player dic |

self flag: #minami. "undo?"

	player := self findPlayerByUUID: self targetId on: board.
	player ifNil: [^ nil].

	dic := Dictionary new.
	dic at: #myself put: player.
	self undoArgs: dic.

	player detachBoardProperties.
	player container remove: player ifAbsent: [].
! !

!SqPlayerRemovedEvent methodsFor: 'properties' stamp: 'MU 2/16/2006 12:14'!
loadProperties: aPlayer
	aPlayer playerId: self targetId.! !

!SqPlayerRemovedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:11'!
type
	^ #playerRemoved! !

!SqPlayerRemovedEvent methodsFor: 'actions' stamp: 'minami 1/31/2006 20:11'!
undo: board
	| aPlayer |
	aPlayer := self undoArgs at: #myself.
	board add: aPlayer.
	self loadProperties: aPlayer.
	! !

SqEvent subclass: #SqPlayerSelectedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerSelectedEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:14'!
execute: board
	| player h |
	player := self findPlayerByUUID: self targetId on: board.
	player ifNil: [^ nil].

	h _ SqSelectionHighlight new.
	h target: player.
	h open.! !

!SqPlayerSelectedEvent methodsFor: 'defaults' stamp: 'minami 1/18/2006 15:20'!
type
	^ #playerSelected! !

SqEvent subclass: #SqPlayerUnlockEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerUnlockEvent methodsFor: 'actions' stamp: 'MU 2/16/2006 12:15'!
execute: board
	board isRecovering ifTrue: [^self].
	board unfreezePlayer: self targetId from: self userId! !

!SqPlayerUnlockEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:05'!
type
	^ #unlock! !

!SqPlayerUnlockEvent methodsFor: 'actions' stamp: 'minami 2/9/2006 11:58'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqRoundCornersChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqRoundCornersChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#roundCorners)	! !

!SqRoundCornersChangedEvent methodsFor: 'defaults' stamp: 'minami 12/27/2005 14:08'!
type
	^ #roundCornersChanged! !

SqEvent subclass: #SqTextChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 15:41'!
defaultEnabledPropertyNames
	^ #(#textEnabled)! !

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#text)	! !

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #textChanged! !

Object subclass: #SqEventPlayer
	instanceVariableNames: 'events board executedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

!SqEventPlayer class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 15:14'!
on: aBoard 
	^ super new on: aBoard;
		 yourself! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:28'!
addAllDifferences: col
	| lae |
	lae := self lastEvent.
	col do: [:evt | 
		(lae eventId < evt eventId) 
			ifTrue: [self events addLast: evt]].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:29'!
addAllFirst: col
	col reverseDo: [:each | self events addFirst: each].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:30'!
addAll: col
	col do: [:each | self events addLast: each].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:28'!
addFirst: event
	^ self events addFirst: event! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:30'!
addLast: event
	^ self events addLast: event! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:27'!
add: event
	^ self events addLast: event! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'minami 12/22/2005 15:16'!
board
	^ board! !

!SqEventPlayer methodsFor: 'initialize' stamp: 'MU 2/10/2006 15:44'!
destroy
	self stop.
	board ifNotNilDo: [:bo | bo boardClient ifNotNilDo: [:bc | bc unregisterEventPlayer: self]].
	
	events _ board _ executedEvents _ nil! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:26'!
events
	events ifNil: [events _ SqSharedCollection new: 100].
	^events! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:27'!
executedEvents
	executedEvents ifNil: [executedEvents _ SqSharedCollection new: 100].
	^executedEvents! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 3/1/2006 17:30'!
executeEvents
	| evt |
	[(evt := self events firstOrNil) isNil] whileFalse: [
		evt execute: self board.
		self executedEvents addLast: evt.
	].
! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 3/17/2006 12:48'!
executeNextEvent
	| evt |
	
	evt := self events firstOrNil ifNil: [^ nil].
	(evt isOnTheSameBoard: board) ifFalse: [^ nil].

	evt displayForDebug: 3.
	
	(board isRecovering
			or: [evt userId ~= board userId
					or: [evt imageId ~= board imageId]])
		ifTrue: [evt execute: self board].
	self executedEvents addLast: evt.

	self hasMoreEventsToPlay ifFalse: [self signal: #allEventsExecuted]
	! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:30'!
firstEvent
	self events notEmpty ifTrue: [^ self events first].
	self executedEvents notEmpty ifTrue: [^ self executedEvents first].
	^ nil! !

!SqEventPlayer methodsFor: 'running' stamp: 'mu 3/1/2006 17:28'!
forward
	self stop.

	[self events isEmpty] whileFalse: [
		self executeNextEvent
	].! !

!SqEventPlayer methodsFor: 'testing' stamp: 'MU 2/10/2006 17:12'!
hasMoreEventsToPlay
	^self isEmpty not! !

!SqEventPlayer methodsFor: 'testing' stamp: 'mu 3/1/2006 17:30'!
isEmpty
	^ self events isEmpty.
! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:28'!
lastEvent
	self events notEmpty ifTrue: [^ events last].
	self executedEvents notEmpty ifTrue: [^ executedEvents last].
	^ nil! !

!SqEventPlayer methodsFor: 'initialize' stamp: 'mu 3/1/2006 17:27'!
on: aBoard
	board := aBoard.
	events := nil.
	executedEvents := nil.
	board boardClient registerEventPlayer: self! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 1/30/2006 15:08'!
play
	self stop.

	self startTicking: #executeNextEvent at: 100! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 1/30/2006 15:09'!
playReverse
	self stop.

	self startTicking: #undoPreviousEvent at: 100! !

!SqEventPlayer methodsFor: 'printing' stamp: 'MU 2/8/2006 16:52'!
printOn: aStream
	aStream nextPutAll: 'a ', self class name, '('.
	events ifNotNilDo: [:o | aStream nextPutAll: ' events: ', o asString]. 
	executedEvents ifNotNilDo: [:o | aStream nextPutAll: ' executedEvents: ', o asString].
	board ifNotNilDo: [:o | aStream nextPutAll: ' board: ', o asString].
	aStream nextPutAll: ')'! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 1/30/2006 15:09'!
stop
	self stopScript: #executeNextEvent.
	self stopScript: #undoPreviousEvent ! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 3/1/2006 17:31'!
undoEvents
	| evt |
	[(evt := self executedEvents lastOrNil) isNil] whileFalse: [
		evt undo: self board.
		self events addFirst: evt.
	].
! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 3/1/2006 17:31'!
undoPreviousEvent
	| evt |
	evt := self executedEvents lastOrNil.
	evt ifNotNil: [	
		evt undo: self board.
		self events addFirst: evt.
	].
! !

!SqEventPlayer methodsFor: 'running' stamp: 'mu 3/1/2006 17:31'!
unwind
	self stop.

	[self executedEvents isEmpty] whileFalse: [
		self undoPreviousEvent
	].! !

!SqEventPlayer methodsFor: 'updating' stamp: 'minami 1/16/2006 12:13'!
update: aspect with: args
	aspect == #eventAdded ifTrue: [self addLast: args].

	super update: aspect with: args! !

Object subclass: #SqEventRecordHolder
	instanceVariableNames: 'events currentNumber mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

!SqEventRecordHolder methodsFor: 'adding' stamp: 'MU 2/22/2006 14:39'!
add: event
	self events notEmpty ifTrue: [self events last = event ifTrue: [^ self]].

	event eventId ifNil: [
		event eventId: self incrementCurrentNumber.
		event setTimeStamp.
	].

	"mutex critical: [self events add: event.]." self flag: #TODO.

	self events add: event.
	self changed: #eventAdded with: event

! !

!SqEventRecordHolder methodsFor: 'actions' stamp: 'mu 4/5/2006 17:25'!
bootstrapEventNumber: lastEventNumberOnBoot

	self events ifEmpty: [^self currentNumber: lastEventNumberOnBoot].

	lastEventNumberOnBoot to: self events size do: [:idx |
		| ev |
		ev _ events at: idx. 
		ev eventId: idx
	].
	! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 3/7/2006 15:07'!
currentNumber
	^currentNumber! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'minami 3/29/2006 15:35'!
currentNumber: anInteger
	currentNumber := anInteger! !

!SqEventRecordHolder methodsFor: 'actions' stamp: 'mu 4/5/2006 17:22'!
dumpUpToEnd
	| oldEvents |
	oldEvents := nil.
	mutex
		critical: [oldEvents := events.
			self initEventRecords].
	^ oldEvents! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 17:22'!
events
	events ifNil: [events := OrderedCollection new:100].
	^ events! !

!SqEventRecordHolder methodsFor: 'actions' stamp: 'MU 2/23/2006 14:58'!
eventsFrom: start to: end 
	^ [self events copyFrom: start to: end]
		on: Error
		do: [:ex | ex
				resignalAs: (SqOutOfRange
						from: start
						to: end
						actualFrom: 1
						to: self events size)]! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 17:22'!
events: collection
	events := collection! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 16:54'!
firstEventNumber
	self events ifEmpty: [^-1. "I have no events"].
	^self events first eventId! !

!SqEventRecordHolder methodsFor: 'private' stamp: 'minami 12/19/2005 16:46'!
incrementCurrentNumber
	currentNumber := currentNumber + 1.
	^ currentNumber! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'mu 4/5/2006 17:22'!
initEventRecords
	events := OrderedCollection new:100! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'MU 2/9/2006 14:58'!
initialize
	super initialize.
	mutex := Semaphore forMutualExclusion.
	self resetEventRecords! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 16:54'!
lastEventNumber
	self events ifEmpty: [^-1. "I have no events"].
	^self events last eventId! !

!SqEventRecordHolder methodsFor: 'actions' stamp: 'MU 2/8/2006 16:16'!
latestEventsFrom: start
	^self eventsFrom: start to: self events size ! !

!SqEventRecordHolder methodsFor: 'printing' stamp: 'MU 2/9/2006 14:54'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	currentNumber ifNotNilDo: [:num | aStream nextPutAll: 'currentNumber: ', num asString].
	aStream nextPutAll: ')'! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'MU 2/10/2006 15:36'!
release
	self resetEventRecords.
	mutex initSignals! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'mu 4/5/2006 16:32'!
resetEventRecords
	self currentNumber: 0. 
	self initEventRecords .! !

Object subclass: #SqExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

!SqExample class methodsFor: 'scripts' stamp: 'MU 2/22/2006 15:46'!
createBoardOnServer
	"SqExample createBoardOnServer"
	| uuid bd |
	uuid := '6018c1ff-8b9c-b140-a2ed-d62f289f8dc5' asUUID.
	bd := SqBoard id: uuid name: 'board1'.
	SqSquareDB default registerGroup: bd.
	^ bd! !

!SqExample class methodsFor: 'scripts' stamp: 'minami 1/26/2006 18:11'!
initRpcServices
	SqRpcDispatcher registerAllServices! !

!SqExample class methodsFor: 'scripts' stamp: 'minami 3/9/2006 15:02'!
startClientByMenu
	"SqExample startClientByMenu"
	| userId password client board boardClient boards menuCol selectedUUID |

	SqConnectionKeeper default start.

	"RPC"
	userId _ UIManager default request: 'userId?'.
	password _ UIManager default requestPassword: userId, '''s password?'.
	client _ SqClient userId: userId.
	(client login: userId password: password) ifFalse: [^ self error: 'login failed'].

	boards _ client boards.
	menuCol _ boards collect: [:e | Array with: e name with: e boardId].

	menuCol _ {{'create new board...'. UUID nilUUID}}, menuCol.
	selectedUUID _ (SelectionMenu fromArray: menuCol) startUp ifNil: [^ self].
	
	board _ selectedUUID = UUID nilUUID 
		ifTrue: [| bn |
				bn _ UIManager default request: 'new board name?'.
				bn isEmptyOrNil ifTrue: [^ self].
				 client createNewBoard: bn]
		ifFalse: [client boardAt: selectedUUID asUUID].

	"Create BoardClient"
	boardClient _ client enterIn: board.

	"Tweak"
	SqUIBuilder default openBoardWindowFor: boardClient! !

!SqExample class methodsFor: 'scripts' stamp: 'MU 1/20/2006 16:39'!
startRpcDispatcher
"
SqExample startRpcDispatcher
"
	SqRpcDispatcher start! !

!SqExample class methodsFor: 'scripts' stamp: 'mu 3/27/2006 15:33'!
startServer
"
SqExample startServer
"
	SqServer default stop.
	SqServer initialize.
	SqServer default start.
	SqServer default inspectAll.
	
	SqAudioChatServerFacade default start; inspect.
	SqServicePublisher startPublish.

	^ SqServer default ! !

!SqExample class methodsFor: 'scripts' stamp: 'mu 3/27/2006 16:14'!
stopAndInitAll
"
SqExample stopAndInitAll
"
	SqAudioChatServerFacade default stop.
	SqConnectionKeeper default stop.
	SqUtil prepareForClient.
	self initRpcServices.

	
	! !

!SqExample class methodsFor: 'scripts' stamp: 'MU 2/23/2006 18:34'!
stopClient
	SqClient closeAll.
! !

!SqExample class methodsFor: 'scripts' stamp: 'minami 1/19/2006 16:45'!
stopServer
	SqServer default stop.
	SqServer initialize.
! !

Object subclass: #SqImageId
	instanceVariableNames: ''
	classVariableNames: 'LastIdString LastImageName LastIp'
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

SqImageId class
	instanceVariableNames: 'current'!

!SqImageId class methodsFor: 'accessing' stamp: 'mu 8/15/2005 11:31'!
current
	^ current! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:34'!
hasEnvironmentChanged
	"SqImageId hasEnvironmentChanged"
	self lastIp ~= self localAddress ifTrue: [^true].
	self lastImageName ~= SmalltalkImage current imageName ifTrue: [^true].
	^false
	! !

!SqImageId class methodsFor: 'class initialization' stamp: 'mu 1/15/2005 01:45'!
initCurrent
	self initCurrent: UUID new.
	! !

!SqImageId class methodsFor: 'class initialization' stamp: 'mu 5/14/2005 00:43'!
initCurrent: uuid 
	| oldCurrent |
	oldCurrent _ current.
	current _ uuid.
	oldCurrent = current
		ifFalse: [self changed: #imageIdNew with: current asString]! !

!SqImageId class methodsFor: 'class initialization' stamp: 'minami 1/13/2006 13:36'!
initialize
	"SqImageId initialize"
	LastIdString _ LastIp _ LastImageName _ nil.
	self nullify.
	self rememberEnvironment.
	self initCurrent.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!SqImageId class methodsFor: 'private' stamp: 'mu 6/18/2005 00:32'!
lastIdString
	LastIdString
		ifNil: [LastIdString _ UUID new asString].
	^ LastIdString! !

!SqImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:40'!
lastImageName
	LastImageName
		ifNil: [LastImageName _ SmalltalkImage current imageName].
	^ LastImageName! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:33'!
lastIp
	LastIp
		ifNil: [LastIp _ self localAddress].
	^ LastIp! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 07:47'!
leave
	"self leave"
	self changed: #imageIdLeave with: current asString.
! !

!SqImageId class methodsFor: 'private' stamp: 'mu 3/31/2006 14:14'!
localAddress
	^SqUtil localAddressStringAskIfDetectionFailed! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 8/15/2005 11:40'!
nullify
	"self nullify"
	self changed: #imageIdNull with: current asString.
	current _ nil
! !

!SqImageId class methodsFor: 'class initialization' stamp: 'minami 1/13/2006 13:34'!
obsolete
	"SqImageId initialize"
	self nullify.
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
	! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:33'!
rememberEnvironment
	current
		ifNotNilDo: [:uid | LastIdString _ uid asString].
	LastIp _ self localAddress.
	LastImageName _ SmalltalkImage current imageName! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 09:00'!
resetTo: uuid 
	| newCurrent |
	newCurrent _ (uuid isMemberOf: UUID)
				ifTrue: [uuid]
				ifFalse: [[UUID fromString: uuid asString]
						on: Error
						do: [:ex | ex return: nil]].
	newCurrent isNil
		ifTrue: [^ self].
	self leave.
	self initCurrent: newCurrent.
	! !

!SqImageId class methodsFor: 'system startup' stamp: 'mu 8/15/2005 11:21'!
shutDown: quitting
	quitting ifTrue: [self leave]! !

!SqImageId class methodsFor: 'system startup' stamp: 'minami 1/13/2006 13:30'!
startUp: resuming 
	self hasEnvironmentChanged
		ifTrue: [self initCurrent]
		ifFalse: [current _ UUID fromString: self lastIdString].
	self rememberEnvironment! !

Object subclass: #SqPlayerEventFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

SqPlayerEventFactory class
	instanceVariableNames: 'eventClassDic'!

!SqPlayerEventFactory class methodsFor: 'private' stamp: 'mu 3/17/2006 11:27'!
buildEventClassDic
	"SqPlayerEventFactory buildEventClassDic"
	| dic |
	dic := Dictionary new.
	(SqEvent allSubclasses reject: [:each | each isCommand]) do: [:each | dic at: each basicNew type put: each name].
	^dic

	
	! !

!SqPlayerEventFactory class methodsFor: 'factory' stamp: 'MU 2/16/2006 13:10'!
createEvent: symbol target: player accessId: accessId args: args
	| clazz |
	clazz := self eventClass: symbol.
	clazz ifNil: [^ nil].

	^ clazz new
		 target: player;
		 accessId: accessId;
		 saveProperties: player withArgs: args; forSend;
		 yourself! !

!SqPlayerEventFactory class methodsFor: 'private' stamp: 'MU 2/15/2006 16:12'!
eventClassDic
	"SqEventFactory eventClassDic"
	eventClassDic ifNil: [eventClassDic := self buildEventClassDic].
	^ eventClassDic! !

!SqPlayerEventFactory class methodsFor: 'factory' stamp: 'minami 1/9/2006 05:05'!
eventClass: eventSymbol 
	
	| clsName |
	clsName := self eventClassDic at: eventSymbol ifAbsent: [].
	clsName ifNil: [self inform: 'UnhandledEvent => ' , eventSymbol. ^ nil].
	
	^ Smalltalk at: clsName ifAbsent: [^ nil].! !

!SqPlayerEventFactory class methodsFor: 'class initialization' stamp: 'minami 1/9/2006 04:48'!
initialize
	eventClassDic := nil! !

Object subclass: #SqProjectSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqProjectSerializer class methodsFor: 'private' stamp: 'mu 3/1/2006 16:00'!
compress: bytes
	^bytes compressIfMoreThan: SqSettings compressThreshold! !

!SqProjectSerializer class methodsFor: 'default serialization' stamp: 'mu 3/1/2006 15:21'!
defaultDeserialize: bytes
	| parts maker player |
	parts _ RmtStreamer unstream: (self uncompress: bytes) by: #default.
	maker _ CObjectMaker new parts: parts.
	player _ maker next.
	^player! !

!SqProjectSerializer class methodsFor: 'default serialization' stamp: 'mu 3/7/2006 15:17'!
defaultSerialize: aCPlayer
	| data |
	data _ CObjectMakerSerializer serialize: aCPlayer.
	"data inspect."
	^self compress: (RmtStreamer stream: data by: #default)! !

!SqProjectSerializer class methodsFor: 'actions' stamp: 'MU 2/24/2006 16:17'!
deserialize: bytes
	| deserializer |
	deserializer _ SqSettings playerSerializer.
	deserializer = #ODF ifTrue: [^self odfDeserialize: bytes].
	^self defaultDeserialize: bytes! !

!SqProjectSerializer class methodsFor: 'odf serialization' stamp: 'MU 2/27/2006 12:00'!
odfDeserialize: bytes 
	| stream player |
	[stream := RWBinaryOrTextStream with: bytes.
	player := [(ODFParser parseOn: stream) firstCPlayer]
				on: Error
				do: [:ex | 
					ex pass.
					"ex log.
					ex return"]]
		ensure: [stream
				ifNotNilDo: [:str | str close]].
	^ Processor activeIsland copy: player! !

!SqProjectSerializer class methodsFor: 'odf serialization' stamp: 'MU 2/24/2006 16:22'!
odfSerialize: aPlayer
	| stream |
	stream := RWBinaryOrTextStream on: (ByteArray new: 500).
	ODF exportPlayer: aPlayer on: stream.
	stream close.
	^stream contents! !

!SqProjectSerializer class methodsFor: 'actions' stamp: 'MU 2/24/2006 16:20'!
serialize: aCPlayer
	| serializer |
	serializer _ SqSettings playerSerializer.
	serializer = #ODF ifTrue: [^self odfSerialize: aCPlayer].
	^self defaultSerialize: aCPlayer! !

!SqProjectSerializer class methodsFor: 'private' stamp: 'mu 3/1/2006 15:20'!
uncompress: bytes
	^bytes uncompressOnDemand! !

Object subclass: #SqSharedCollection
	instanceVariableNames: 'contentsCollection accessProtect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqSharedCollection class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 17:16'!
new
	^ self new: 10! !

!SqSharedCollection class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 17:18'!
new: anInteger 
	^super new init: anInteger! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:46'!
addFirst: value 
	accessProtect critical: [contentsCollection addFirst: value].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:46'!
addLast: value 
	accessProtect critical: [contentsCollection addLast: value].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:13'!
first
	^ contentsCollection first! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
firstOrNil
	| value |

	accessProtect critical: [
		value := self isEmpty 
			ifTrue: [nil]
			ifFalse: [contentsCollection removeFirst].
	].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
flush
	"Throw out all pending contents"
	accessProtect critical: [
		contentsCollection := OrderedCollection new: 10.
	].! !

!SqSharedCollection methodsFor: 'private' stamp: 'minami 12/26/2005 16:47'!
init: size 
	contentsCollection := OrderedCollection new: size.
	accessProtect := Semaphore forMutualExclusion.
! !

!SqSharedCollection methodsFor: 'testing' stamp: 'minami 12/22/2005 14:50'!
isEmpty
	^ contentsCollection isEmpty! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:13'!
last
	^ contentsCollection last! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
lastOrNil
	| value |

	accessProtect critical: [
		value := self isEmpty 
			ifTrue: [nil]
			ifFalse: [contentsCollection removeLast].
	].
	^value! !

!SqSharedCollection methodsFor: 'testing' stamp: 'minami 12/26/2005 16:12'!
notEmpty
	^ self isEmpty not! !

!SqSharedCollection methodsFor: 'printing' stamp: 'MU 2/8/2006 16:45'!
printOn: aStream
	aStream nextPutAll: 'a ', self class name, '('.
	aStream nextPutAll: contentsCollection asString.
	aStream nextPutAll: ')'! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/22/2005 14:55'!
size
	"Answer the number of objects that have been sent through the
	receiver and not yet received by anyone."

	^ contentsCollection size! !

!CHalo methodsFor: '*SqSquare-Core-override' stamp: 'MU 2/13/2006 15:48'!
handleSpecs
	"Answer specs defining the halo handles to use."

	^ Preferences debugHaloHandle
	 	ifFalse:
			[{{#haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.5.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.5.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.5.		Color cyan. 'v'. 	'Open Viewer'	}}]
		ifTrue:
			[{{ #haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.66667.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.66667.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloDebug.  1.0.		0.33333.		Color cyan muchLighter. 'D'. 'Debug'}.
			{ #haloTile.      0.0.		0.33333.	Color orange.	 't'.		'Tile'			}.
			{ #haloLink.      0.0.		0.5.	Color palePeach.	 'l'.		'Link'			}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.66667.		Color cyan. 'v'. 	'Open Viewer'	}}]
	! !

!CHalo methodsFor: '*SqSquare-Core-override' stamp: 'minami 2/16/2006 09:10'!
onSelectTarget
	| index list cc aHand boardPos |
	aHand := self hand.
	list := aHand playersUnder: aHand world.
	list isEmpty ifTrue:[^self].
"list inspect."
	boardPos := list findLast: [:e | e player findPlayerOf: SqBoardWindow].
	boardPos >= 3 ifTrue: [
		list := (list first: (boardPos - 1)) reverse , (list allButFirst: boardPos).
	].
"list inspect."
	cc := self target ifNotNil:[self target asPrimCostume].
	index := list identityIndexOf: (cc ifNil:[self rootContext]).
	index = 0 ifTrue:[
		aHand shiftPressed 
			ifTrue:[index := 1]
			ifFalse:[index := list size - 1]
	] ifFalse:[
		aHand shiftPressed
			ifTrue:[index := index+1]
			ifFalse:[index := index-1].
	].
	"@@@@: Fix this. Later figure out how to wrap and ask guys for interest"
	self target: (list atWrap: index) asPlayer haloTarget! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/20/2006 12:29'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(vertices) from: dic ! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/20/2006 12:29'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(vertices) into: dic ! !

CPolygonPlayer subclass: #SqLineConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqLineConnector class
	instanceVariableNames: 'cachedColors'!

SqLineConnector defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="fromTarget" toSet="fromTarget:" changeEvent="fromTargetChanged">fromTarget</field>
	<field toGet="toTarget" toSet="toTarget:" changeEvent="toTargetChanged">toTarget</field>
	<field toGet="alphaIndex" toSet="alphaIndex:" changeEvent="alphaIndexChanged">alphaIndex</field>
	<field toGet="lastPos" toSet="lastPos:" changeEvent="lastPosChanged">lastPos</field>
	<field toGet="lastVertices" toSet="lastVertices:" changeEvent="lastVerticesChanged">lastVertices</field>
	<field toGet="constraintType" toSet="constraintType:" changeEvent="constraintTypeChanged">constraintType</field>
	<field toGet="fadeType" toSet="fadeType:" changeEvent="fadeTypeChanged">fadeType</field>
</fields>'!

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
baseColor
	^ Color green! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColorSize
	^ 100
! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColors
"
	TXLineConnector cachedColors.
"
	| bColor delta |
	bColor := self baseColor.
	delta := 0.01.

	cachedColors isNil ifTrue: [
		cachedColors := OrderedCollection new: self frequency.
		1 to: self cachedColorSize do: [:idx |
			cachedColors add: (bColor alpha: idx * delta).
		].
		cachedColors at: 1 put: Color transparent.
		cachedColors at: self cachedColorSize put: bColor.
	].
	
	^ cachedColors! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
defaultWidth
	^ 5! !

!SqLineConnector class methodsFor: 'examples' stamp: 'minami 2/20/2006 12:06'!
ex01
"
	SqLineConnector ex01
"
	| c |
	c := SqLineConnector newWithConstraint.
	c open.
	^ c! !

!SqLineConnector class methodsFor: 'examples' stamp: 'minami 2/20/2006 12:06'!
ex02
"
	SqLineConnector ex02
"
	| c |
	c := SqLineConnector newWithConstraint.
	c fromTarget 
			constraintType: #fix;
			constraintPoint: #bottomLeft.
	c toTarget constraintType: #free.

	c open.
	^ c! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
frequency
	^ 10! !

!SqLineConnector class methodsFor: 'instance creation' stamp: 'minami 10/26/2005 04:23'!
from: fromTarget to: toTarget 
	^ super new 
		 setFromTarget: fromTarget toTarget: toTarget;
		 yourself! !

!SqLineConnector class methodsFor: 'class initialization' stamp: 'minami 10/26/2005 03:08'!
initialize
"
	TXLineConnector initialize.
"
	cachedColors := nil.! !

!SqLineConnector class methodsFor: 'instance creation' stamp: 'minami 2/20/2006 12:06'!
newWithConstraint
	| inst |
	inst := self from: SqConstraintPlayer new to: SqConstraintPlayer new.
	inst start.
	^ inst
	! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
alphaIndex
	"Answer the alphaIndex of the receiver"
	<bewareOf: #alphaIndexChanged>
	^self propertyValueAt: #alphaIndex! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
alphaIndex: aValue
	"Modify the receiver's alphaIndex"
	^self propertyValueAt: #alphaIndex put: aValue with: #alphaIndexChanged! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColorSize
	^ self class cachedColorSize! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColors
	^ self class cachedColors! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 11/1/2005 13:11'!
computeFromPos
	| fromBounds toBounds newPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	((constraintType == #centerToCenter) or: [constraintType == #centerToEdge])
		ifTrue: [^ self fromTarget globalPosition].
	
	fromBounds := self fromTarget globalBounds.
	toBounds := self toTarget globalBounds.

	newPos := fromBounds intersectionWithLineSegmentFromCenterTo: toBounds center.
	
	^ newPos asIntegerPoint
! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 11/1/2005 13:11'!
computeToPos
	| fromBounds toBounds newPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	((constraintType == #centerToCenter) or: [constraintType == #edgeToCenter])
		ifTrue: [^ self toTarget position].
	
	fromBounds := self fromTarget globalBounds.
	toBounds := self toTarget globalBounds.

	newPos := toBounds intersectionWithLineSegmentFromCenterTo: fromBounds center.
	^ newPos asIntegerPoint
! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
constraintType
	"Answer the constraintType of the receiver"
	<bewareOf: #constraintTypeChanged>
	^self propertyValueAt: #constraintType! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
constraintType: aValue
	"Modify the receiver's constraintType"
	^self propertyValueAt: #constraintType put: aValue with: #constraintTypeChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 13:33'!
decreaseAlpha
	self alphaIndex > 1 ifTrue: [self alphaIndex: self alphaIndex - 1].
	self setAlpha: self alphaIndex.! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
defaultWidth
	^ self class defaultWidth! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 15:42'!
deleteIf: conditionBlock 
	self deleteIf: conditionBlock postScript: []! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
deleteIf: conditionBlock postScript: postScriptBlock 
	(conditionBlock value: self) ifTrue: [
		postScriptBlock value: self.
		self destroy.
	]! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/30/2005 14:02'!
fadeType
	"Answer the fadeType of the receiver"
	<bewareOf: #fadeTypeChanged>
	^self propertyValueAt: #fadeType! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/30/2005 14:02'!
fadeType: aValue
	"Modify the receiver's fadeType"
	^self propertyValueAt: #fadeType put: aValue with: #fadeTypeChanged! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
fromTarget
	"Answer the fromTarget of the receiver"
	<bewareOf: #fromTargetChanged>
	^self propertyValueAt: #fromTarget! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
fromTarget: aValue
	"Modify the receiver's fromTarget"
	^self propertyValueAt: #fromTarget put: aValue with: #fromTargetChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 14:16'!
increaseAlpha
	self cachedColorSize > self alphaIndex ifTrue: [self alphaIndex: self alphaIndex + 1].
	self setAlpha: self alphaIndex.! !

!SqLineConnector methodsFor: 'initialize' stamp: 'minami 10/30/2005 14:02'!
initialize
	super initialize.

	alphaIndex := self cachedColorSize.
	lastPos := nil.
	lastVertices := nil.
	constraintType := #centerToCenter. "#centerToCenter, #centerToEdge, #edgeToCenter, #edgeToEdge"
	arrowStyle := #forward. "#none, #forward, #back, #both"
	arrowSpec := 4@5.
	closed := false.

	borderWidth := self defaultWidth.
	color := self class baseColor.
	borderColor := self class baseColor.

	fadeType := #still. "{#out. #in. #still}"! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastPos
	"Answer the lastPos of the receiver"
	<bewareOf: #lastPosChanged>
	^self propertyValueAt: #lastPos! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastPos: aValue
	"Modify the receiver's lastPos"
	^self propertyValueAt: #lastPos put: aValue with: #lastPosChanged! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastVertices
	"Answer the lastVertices of the receiver"
	<bewareOf: #lastVerticesChanged>
	^self propertyValueAt: #lastVertices! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastVertices: aValue
	"Modify the receiver's lastVertices"
	^self propertyValueAt: #lastVertices put: aValue with: #lastVerticesChanged! !

!SqLineConnector methodsFor: 'events' stamp: 'minami 10/30/2005 13:24'!
onBorderChanged
	| radius oldBox newBox |
	<on: borderChanged>
	radius := (borderWidth + 1) // 2.
	oldBox := Rectangle encompassing: self getVertices.
	newBox := (0@0 extent: width@height) insetBy: radius.
	(oldBox width < 1 or:[oldBox height < 1]) ifTrue:[
		extent := (oldBox expandBy: radius) extent.
		^self].
	(newBox width < 1 or:[newBox height < 1]) ifTrue:[
		extent := ((oldBox origin extent: 1@1) expandBy: radius) extent.
		^self].! !

!SqLineConnector methodsFor: 'events' stamp: 'minami 2/20/2006 12:06'!
onMouseEnter: evt
	<on: mouseEnter>

	(self fromTarget isKindOf: SqConstraintPlayer) ifTrue: [self fromTarget comeToFront].
	(self toTarget isKindOf: SqConstraintPlayer) ifTrue: [self toTarget comeToFront].
! !

!SqLineConnector methodsFor: 'opening' stamp: 'minami 2/20/2006 12:06'!
open: aPlayer in: aContainer at: aPoint
	super open: aPlayer in: aContainer at: aPoint.

	(self fromTarget isKindOf: SqConstraintPlayer)
		ifTrue: [self fromTarget open].
	(self toTarget isKindOf: SqConstraintPlayer)
		ifTrue: [self toTarget open]! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
privUpdateConnector
	| pos newFromPos newToPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	newFromPos := self computeFromPos.
	newToPos := self computeToPos.
	self setNewVertices: {newFromPos. newToPos.}.
	pos := (newFromPos corner: newToPos) center.
	self position: pos.

! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
resetAlpha
	self alphaIndex: self cachedColorSize! !

!SqLineConnector methodsFor: 'private' stamp: 'minami 10/26/2005 03:08'!
setAlpha: index
	| c |
	c := self cachedColors at: index.
	self borderColor: c.
! !

!SqLineConnector methodsFor: 'private' stamp: 'minami 2/20/2006 12:06'!
setFromTarget: from toTarget: to 
	self fromTarget: from.
	self toTarget: to.
	(from isKindOf: SqConstraintPlayer)
		ifTrue: [from connector: self edge: #from].
	(to isKindOf: SqConstraintPlayer)
		ifTrue: [to connector: self edge: #to]! !

!SqLineConnector methodsFor: 'private' stamp: 'minami 10/26/2005 03:08'!
setNewVertices: points
	vertices := points.
	self onVerticesChanged! !

!SqLineConnector methodsFor: 'initialize' stamp: 'minami 10/30/2005 14:19'!
setupCostume
	super setupCostume.

! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:39'!
start
	self startScript: #updateConnector when: {self fromTarget. #geometryChanged}.
	self startScript: #updateConnector when: {self toTarget. #geometryChanged}.

	self startScript: #onMouseEnter: when: {self fromTarget. #mouseEnter}.

	self startTicking: #updateBorderColor at: 10.

	self updateConnector.! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:42'!
startAndDeleteIf: conditionBlock
	self startAndDeleteIf: conditionBlock postScript: []! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:41'!
startAndDeleteIf: conditionBlock postScript: postScriptBlock 

	self
		startTicking: #deleteIf:postScript:
		withArguments: {conditionBlock. postScriptBlock}
		at: 10.

	self start.! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:49'!
stop
	self stopScript: #updateConnector.
	self stopScript: #updateBorderColor.
	self stopScript: #onMouseEnter:.
	self stopScript: #deleteIf:postScript:.
! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
toTarget
	"Answer the toTarget of the receiver"
	<bewareOf: #toTargetChanged>
	^self propertyValueAt: #toTarget! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
toTarget: aValue
	"Modify the receiver's toTarget"
	^self propertyValueAt: #toTarget put: aValue with: #toTargetChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 14:07'!
updateBorderColor
	self fadeType = #out
		ifTrue: [self decreaseAlpha].
	self fadeType = #in
		ifTrue: [self increaseAlpha]! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:09'!
updateConnector
	self privUpdateConnector.
"	self comeToFront."

! !

!CLabel methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 17:15'!
isLabel
	^true! !

RmtTcpService subclass: #SqTcpService
	instanceVariableNames: 'onAccepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqTcpService methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:34'!
onAccepted
	onAccepted ifNil: [onAccepted _ [:acc | ]].
	^onAccepted! !

!SqTcpService methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:34'!
onAccepted: aBlock
	onAccepted _ aBlock! !

!SqTcpService methodsFor: 'conversation' stamp: 'MU 1/20/2006 19:23'!
serve: aSocket 
	| newAcceptor times |
	newAcceptor := self acceptorClass new.
	newAcceptor isAcceptor
		ifFalse: [self error: newAcceptor asString , 'is not an Acceptor'].
	acceptors add: newAcceptor.
	newAcceptor on: aSocket.
	
	times _ 0.
	[times < 3 and: [newAcceptor accessId isNil]] whileTrue: [
		(Delay forSeconds: 1) wait.
		times _ times + 1.
	].
	newAcceptor accessId ifNil: [^newAcceptor close].

	self onAccepted value: newAcceptor.
	! !

!SqTcpService methodsFor: 'actions' stamp: 'minami 1/13/2006 11:50'!
try: tryBlock times: anInteger while: whileBlock
	| times |
	times _ 0.
	[times < anInteger] whileTrue: [
		whileBlock value ifFalse: [^ true].

		tryBlock value.
		(Delay forSeconds: 1) wait.
	].

	^ false! !

CObjectMakerSerializer subclass: #SqPlayerSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerSerializer methodsFor: 'private-writing' stamp: 'mu 3/2/2006 15:28'!
writeContentsOf: anObject
	"Write the contents of the given object"
	anObject writeMementoFieldsOn: self! !

CProjectShell subclass: #SqProjectShell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Experimental'!

SqProjectShell defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqProjectShell methodsFor: 'initialize' stamp: 'minami 1/20/2006 12:21'!
newProject
	myIsland := CProjectIsland new.
	myIsland scheduler: (myIsland new: ScriptScheduler).
	myIsland project: (myProject := myIsland new: SqEToysProject).
	myProject newProject.! !

!EToyScriptManager methodsFor: '*SqSquare-Core-lookup' stamp: 'MU 2/20/2006 17:06'!
uniClassAt: uniClassID 
	^ self allUniClassInstances
		detect: [:each | each class classVersionID = uniClassID]
		ifNone: []! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:02'!
postBuildWith: aMaker
	"Now that the player is fully loaded, make sure we're initialized correctly"
	self autoStartScripts.
"	self setupCostume."
	"For now, call #makeDefaultCostume so that we keep compatibility"
		self makeDefaultCostume.
	self signalChanged: #playerChanged from: nil to: myPlayer.! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:03'!
readFieldsFrom: deSerializer
	"By default, costumes only remember their player since they can be perfectly recreated after the player came back in. Note that the process is a little tricky since the player may not have been fully loaded yet and therefore we cannot initialize the receiver quite yet. This only happens in #postBuildWith: which is invoked once everything is loaded"
	myPlayer := deSerializer readField: #player ifAbsent:[myPlayer].
	myPlayer privateChangeCostumeTo: self.

	self initialize.
	transform := deSerializer readField: #transform ifAbsent:[transform].
	extent := deSerializer readField: #extent ifAbsent:[extent].

	myCostume := deSerializer readField: #costume ifAbsent:[myCostume].

! !

!CCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:03'!
writeFieldsOn: aSerializer
	"By default, costumes only remember their player since they can be perfectly recreated after the player came back in"
	aSerializer writeField: #player value: player.
	aSerializer writeField: #transform value: transform.
	aSerializer writeField: #extent value: extent.

	aSerializer writeField: #costume value: myCostume.! !

!CCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:49'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CCostume subclass: #SqTabsHolderCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabsHolderCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="tabPane" toSet="tabPane:" changeEvent="tabPaneChanged">tabPane</field>
	<field toGet="contentHolder" toSet="contentHolder:" changeEvent="contentHolderChanged">contentHolder</field>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
</fields>'!

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:22'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:22'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqTabsHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 11:58'!
buildContentHolder
	| aHolder |
	aHolder := CPlayer new.

	aHolder hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aHolder color: self defaultContentHolderColor.


	^ aHolder
! !

!SqTabsHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 14:25'!
buildTabPane
	| aPane |
	aPane := CPlayer new.

	aPane hResizing: #shrinkWrap.
	aPane height: 20.
	aPane layout: CTableLayout new.
	aPane layout listDirection: #leftToRight.

	aPane color: self defaultTabPaneColor.

	^ aPane
! !

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
contentHolder
	"Answer the contentHolder of the receiver"
	<bewareOf: #contentHolderChanged>
	^self propertyValueAt: #contentHolder! !

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
contentHolder: aValue
	"Modify the receiver's contentHolder"
	^self propertyValueAt: #contentHolder put: aValue with: #contentHolderChanged! !

!SqTabsHolderCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 11:25'!
defaultContentHolderColor
	^ Color lightGray! !

!SqTabsHolderCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 14:56'!
defaultMenuPaneColor
	^ Color lightRed! !

!SqTabsHolderCostume methodsFor: 'initialize' stamp: 'mu 4/5/2006 11:13'!
defaultPlayer
	^ SqTabsHolder! !

!SqTabsHolderCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 11:46'!
defaultTabPaneColor
	^ Color lightOrange! !

!SqTabsHolderCostume methodsFor: 'initialize' stamp: 'minami 3/17/2006 14:52'!
initialize
	super initialize.

	self define: #contentHolder as: self buildContentHolder.
	self define: #tabPane as: self buildTabPane.! !

!SqTabsHolderCostume methodsFor: 'events' stamp: 'minami 3/20/2006 11:22'!
onActiveContentChanged
	<on: activeContentChanged in: player>

	self activeContent == player activeContent ifTrue: [^ self].

	self activeContent ifNotNil: [
		self contentHolder remove: self activeContent.
	].
	self activeContent: player activeContent.
	self contentHolder addLast: self activeContent.! !

!SqTabsHolderCostume methodsFor: 'events' stamp: 'minami 3/17/2006 12:47'!
onPlayerContentAdded: addedPlayer
	| aButton |
	<on: contentAdded in: player>

	aButton := SqTabButton new 
				content: addedPlayer;
				holder: player;
				label: addedPlayer title;
				yourself.
	self tabPane add: aButton! !

!SqTabsHolderCostume methodsFor: 'initialize' stamp: 'minami 3/17/2006 14:28'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.
	self layout wrapDirection: #topToBottom.
	self layout listCentering: #leftToRight.

	self addLast: self tabPane.
	self addLast: self contentHolder.
! !

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
tabPane
	"Answer the tabPane of the receiver"
	<bewareOf: #tabPaneChanged>
	^self propertyValueAt: #tabPane! !

!SqTabsHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
tabPane: aValue
	"Modify the receiver's tabPane"
	^self propertyValueAt: #tabPane put: aValue with: #tabPaneChanged! !

AbInitializer subclass: #SqInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqInitializer class methodsFor: 'private' stamp: 'mu 3/27/2006 16:15'!
systemShutDown: quitting

	quitting ifFalse: [^ self].

	
! !

!SqInitializer class methodsFor: 'private' stamp: 'mu 4/4/2006 18:27'!
systemStartUp: resuming

	resuming ifFalse: [^ self].

	SqSettings configure.
	SqPlayerEventFactory initialize.

	SqExternalConnection purgeAll.
	SqSettings isClientOnly ifTrue: [SqUtil prepareForClient].
	SqSettings isServer ifTrue: [SqUtil prepareForServer].

	
! !

!CCostumeTextHolder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeTextHolder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CProjectMorph subclass: #SqProjectMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Experimental'!

!SqProjectMorph methodsFor: 'initialization' stamp: 'minami 1/20/2006 12:17'!
newProject: worldMaker
	| world |
	island := CProjectIsland new.
	island scheduler: (island new: ScriptScheduler).
	island project: (project := island new: SqEToysProject).
	world := island new: worldMaker.
	((worldMaker includesBehavior: CPanel) and:[world window == nil]) ifTrue:[
		world window: self.
	].
	project newProjectWith: world.
	self setExtentFromWorld.! !

CEventBehavior subclass: #SqEventRecordBehavior
	instanceVariableNames: 'prevEvent prevText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqEventRecordBehavior defineFields: '<?xml  version="1.0" ?>
<fields>
	<field serializable="false" toGet="board" toSet="board:" changeEvent="boardChanged" color="FFFF00">board</field>
	<field toGet="targetId" toSet="targetId:" changeEvent="targetIdChanged">targetId</field>
	<field instanceVariable="true" serializable="false" toGet="prevEvent" toSet="prevEvent:" color="FFFF00">prevEvent</field>
	<field instanceVariable="true" toGet="prevText" toSet="prevText:" color="FFFF00">prevText</field>
</fields>'!

!SqEventRecordBehavior methodsFor: 'initialize' stamp: 'minami 2/27/2006 08:24'!
attachTo: anObject
	super attachTo: anObject.
	self targetId: anObject playerId
! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 12/16/2005 15:21'!
board
	"Answer the board of the receiver"
	<bewareOf: #boardChanged>
	^self propertyValueAt: #board! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 12/16/2005 15:21'!
board: aValue
	"Modify the receiver's board"
	^self propertyValueAt: #board put: aValue with: #boardChanged! !

!SqEventRecordBehavior methodsFor: 'testing' stamp: 'mu 3/16/2006 13:15'!
canOmitEventTyped: eventType
	prevEvent ifNil: [^false].
	^(prevEvent type == eventType
			and: [prevEvent millisecondsFromCurrent < SqSettings omitEventThreshold])
		! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/16/2006 13:15'!
client
	^ SqClient userId: self board userId! !

!SqEventRecordBehavior methodsFor: 'testing' stamp: 'mu 3/10/2006 16:07'!
isEventRecordBehavior
	^true! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 12/15/2005 14:34'!
onBorderChanged
	<on: borderChanged in: target>
	self recordEvent: #borderChanged! !

!SqEventRecordBehavior methodsFor: 'events - drag and drop' stamp: 'minami 2/9/2006 12:02'!
onDragEnter: evt
	<on: dragEnter in: target>
	
	evt hand dragContents == self target ifFalse: [^ self].
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - drag and drop' stamp: 'minami 3/30/2006 12:17'!
onDropAccept: aPlayer
	<on: dropAccept in: target>

	self recordEvent: #unlock.

	(aPlayer isBoard) ifTrue: [
		self recordEvent: #dropAccept.
		^ self
	].

	((aPlayer isComplexPlayer) and: [aPlayer hasPlayerId]) ifTrue: [
		self recordEvent: #dropAccept with: aPlayer.
		^ self.
	].

	self recordEvent: #playerRemoved.
	self target detachBoardProperties.! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 2/13/2006 16:01'!
onFillChanged
	<on: fillChanged in: target>
	self recordEvent: #fillChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 12/27/2005 14:14'!
onFlagsChanged
	<on: flagsChanged in: target>
	self recordEvent: #flagsChanged.
! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 3/9/2006 14:41'!
onGeometryChanged
	<on: geometryChanged in: target >
	(self canOmitEventTyped: #geometryChanged)
		ifTrue: [^ self].
	self recordEvent: #geometryChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 3/16/2006 10:17'!
onGraphicChanged
	<on: graphicChanged in: target>
	(self target wantsPropagateGraphicChanged) ifFalse: [^ self].
	(self canOmitEventTyped: #graphicChanged)
		ifTrue: [^ self].
	self recordEvent: #graphicChanged! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/7/2006 19:31'!
onHaloDismiss
	<on: haloDismiss in: target>

	self recordEvent: #unlock.
	self recordEvent: #playerRemoved.
	self target removePlayerId.
	self detach.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:50'!
onHaloDrag
	<on: haloDrag in: target>
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:54'!
onHaloDragFinished
	<on: haloDragFinished in: target>	
	self recordEvent: #unlock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 1/17/2006 16:37'!
onHaloDup
"
	<on: haloDup in: target>	
"
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:50'!
onHaloGrab
	<on: haloGrab in: target>
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 1/19/2006 17:01'!
onHaloGrabFinished
	<on: haloGrabFinished in: target>	
	self recordEvent: #unlock.
! !

!SqEventRecordBehavior methodsFor: 'events - button' stamp: 'minami 2/17/2006 15:02'!
onImageChanged
"
	<on: imageChanged in: target>
	self recordEvent: #imageChanged.
"! !

!SqEventRecordBehavior methodsFor: 'events - button' stamp: 'MU 2/15/2006 16:35'!
onLabelChanged
	<on: labelChanged in: target>
	self recordEvent: #labelChanged.
! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 12/27/2005 14:19'!
onRoundCornersChanged
	<on: roundCornersChanged in: target>
	self recordEvent: #roundCornersChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 3/16/2006 10:17'!
onTextChanged
	<on: textChanged in: target>

	(self target wantsPropagateTextChanged) ifFalse: [^ self].

	self recordEvent: #textChanged! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/9/2006 11:24'!
prevEvent
	"Answer the prevEvent of the receiver"
	^prevEvent! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/9/2006 11:24'!
prevEvent: aValue
	"Modify the receiver's prevEvent"
	prevEvent := aValue! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/16/2006 10:21'!
prevText
	"Answer the prevText of the receiver"
	^prevText! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/16/2006 10:21'!
prevText: aValue
	"Modify the receiver's prevText"
	prevText := aValue! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'minami 12/15/2005 14:32'!
recordEvent: evtSymbol 
	self recordEvent: evtSymbol withArguments: #()! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'minami 4/4/2006 11:48'!
recordEvent: evtSymbol withArguments: args 
	| evt |

	self target ifNil: [^ self].
	self target isRecording ifFalse: [^ self].
	self board ifNil: [^ self].
	self board isRecording ifFalse: [^ self].

	target container ifNil: [^ self].
	((target container == board) 
		or: [target container isComplexPlayer] 
		or:[{#playerRemoved. 
			#dropAccept. 
			#lock. 
			#unlock } includes: evtSymbol]) ifFalse: [^ self].

	evt := SqPlayerEventFactory
				createEvent: evtSymbol
				target: self target
				accessId: self board accessId
				args: args.

	self board recordEvent: evt.
	prevEvent _ evt setMillisecondsStamp.

	board signal: #contentsChanged.
! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'minami 12/15/2005 14:32'!
recordEvent: evtSymbol with: arg1
	self recordEvent: evtSymbol withArguments: {arg1}! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'minami 12/15/2005 14:32'!
recordEvent: evtSymbol with: arg1 with: arg2
	self recordEvent: evtSymbol withArguments: {arg1. arg2}! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'minami 12/15/2005 14:32'!
recordEvent: evtSymbol with: arg1 with: arg2 with: arg3
	self recordEvent: evtSymbol withArguments: {arg1. arg2. arg3}! !

!SqEventRecordBehavior methodsFor: 'events - other' stamp: 'minami 12/26/2005 15:55'!
scriptStatusChanged: scriptSymbol
	
	self flag: #minami.

"	<on: scriptStatusChanged in: target>
	self recordEvent: #scriptStatusChanged with: scriptSymbol
"
	! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 2/27/2006 15:34'!
targetId
	"Answer the targetId of the receiver"
	<bewareOf: #targetIdChanged>
	^self propertyValueAt: #targetId! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 3/17/2006 10:53'!
targetId: aValue
	"Modify the receiver's targetId"

	^self propertyValueAt: #targetId put: aValue with: #targetIdChanged! !

RmtConnector subclass: #SqConnector
	instanceVariableNames: 'accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnector class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 19:48'!
connect: ipAddressOrHost port: portNumber accessId: id
	| inst |
	inst _ self new.
	inst accessId: id.
	^inst connect: ipAddressOrHost port: portNumber 
	! !

!SqConnector class methodsFor: 'instance creation' stamp: 'mu 12/28/2005 18:57'!
with: connectedSocket
	^self new with: connectedSocket! !

!SqConnector methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:39'!
accessId
	^accessId! !

!SqConnector methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:39'!
accessId: id
	^accessId _ id! !

!SqConnector methodsFor: 'converting' stamp: 'mu 12/28/2005 20:11'!
asAcceptor
	^SqAcceptor with: self socket! !

!SqConnector methodsFor: 'factory' stamp: 'minami 1/12/2006 12:17'!
messageClass
	^SqMessage! !

!SqConnector methodsFor: 'sending' stamp: 'minami 1/13/2006 14:11'!
negotiate: aSqAccessId
	| msg msgData |
	msg _ self messageClass typed: #negotiate on: aSqAccessId encoder: #default.
	msgData _ msg rawData.
	self basicSendData: msgData.
	self flush.
	^nil
! !

!SqConnector methodsFor: 'private' stamp: 'MU 1/20/2006 19:52'!
onConnected
	self negotiate: self accessId.
	super onConnected! !

!SqConnector methodsFor: 'initialize-release' stamp: 'minami 1/12/2006 17:10'!
with: aSocket
	socketStream _ self createSocketStream: aSocket.
	self negotiate
		ifTrue: [self prepareHeartbeatProcess]
		ifFalse: [self close.
			RmtNetworkError signal: 'Negotiation failed' tagged: #negotiationFailed]! !

!CButton methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:06'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.
	self loadProperties: #(label image) from: dic 
	! !

!CButton methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:43'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(label image) into: dic 
	! !

CButton subclass: #SqLinkTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Link'!

SqLinkTile defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="targetId" toSet="targetId:" changeEvent="targetIdChanged">targetId</field>
</fields>'!

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/17/2006 10:55'!
board
	| cont |
	cont := self eventRecordBoard.
	^ cont! !

!SqLinkTile methodsFor: 'initialize' stamp: 'MU 2/15/2006 14:41'!
initialize	
	super initialize.

	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	
	! !

!SqLinkTile methodsFor: 'actions' stamp: 'MU 2/17/2006 13:41'!
jump
	| moved |
	self board ifNil: [^ self].
	self board isBoard ifFalse: [^ self].
	moved := self board stepScrollToward: self target.
	moved
		ifTrue: [self target
				stopRecordingWhile: [self target flash.
					self target waitTick]]
		ifFalse: [self notifyBadLink]! !

!SqLinkTile methodsFor: 'load/save' stamp: 'MU 2/16/2006 17:04'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.
	self loadProperties: #(targetId) from: dic ! !

!SqLinkTile methodsFor: 'actions' stamp: 'MU 2/17/2006 13:39'!
notifyBadLink
	^self inform: 'bad link!!'! !

!SqLinkTile methodsFor: 'events' stamp: 'MU 2/15/2006 15:39'!
onFire
	"Fire this button"
	<on: fire>
	Beeper beep.
	self jump.! !

!SqLinkTile methodsFor: 'events' stamp: 'mu 3/10/2006 12:18'!
onGeometryChanged
	<on: geometryChanged in: value>
	self image: self target icon.

! !

!SqLinkTile methodsFor: 'events' stamp: 'minami 2/17/2006 14:54'!
onGraphicChanged
	<on: graphicChanged in: value>

	self image: self target icon.! !

!SqLinkTile methodsFor: 'events' stamp: 'MU 2/14/2006 15:42'!
onNameChanged
	<on: nameChanged in: value>

	self name: self target name.

! !

!SqLinkTile methodsFor: 'opening' stamp: 'MU 2/17/2006 13:22'!
openInHand
	super openInHand.
	self postOpen! !

!SqLinkTile methodsFor: 'opening' stamp: 'mu 3/27/2006 11:30'!
postOpen
	self borderColor: Color red.
	
	self label: self target name.
	self target isLabel ifFalse: [self image: self target icon].

	self balloonHelp: 'Link to: ', self target name.

	Beeper beep! !

!SqLinkTile methodsFor: 'private' stamp: 'MU 2/14/2006 17:22'!
retrieveTarget
	
	^value _ self board findPlayerByUUID: self targetId! !

!SqLinkTile methodsFor: 'load/save' stamp: 'MU 2/16/2006 16:57'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.
	self saveProperties: #(targetId) into: dic ! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/16/2006 17:03'!
target
	value ifNil: [self retrieveTarget].
	^value! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/15/2006 15:02'!
targetId
	"Answer the targetId of the receiver"
	<bewareOf: #targetIdChanged>
	^self propertyValueAt: #targetId! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/15/2006 15:02'!
targetId: aValue
	"Modify the receiver's targetId"
	^self propertyValueAt: #targetId put: aValue with: #targetIdChanged! !

!SqLinkTile methodsFor: 'testing' stamp: 'mu 3/16/2006 10:17'!
wantsPropagateGraphicChanged
	^false! !

!SqLinkTile methodsFor: 'testing' stamp: 'mu 3/16/2006 10:16'!
wantsPropagateTextChanged
	^false! !

!SqLinkTile methodsFor: 'serializing' stamp: 'MU 2/15/2006 15:08'!
writeFieldsOn: aSerializer
	value _ nil.
	super writeFieldsOn: aSerializer! !

!SqLinkTile methodsFor: 'serializing' stamp: 'mu 3/7/2006 12:10'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CButton subclass: #SqTabButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="content" toSet="content:" changeEvent="contentChanged">content</field>
	<field toGet="holder" toSet="holder:" changeEvent="holderChanged">holder</field>
</fields>'!

!SqTabButton methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:17'!
close
	content _ holder _ nil.
	super close.! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:09'!
content
	"Answer the content of the receiver"
	<bewareOf: #contentChanged>
	^self propertyValueAt: #content! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:09'!
content: aValue
	"Modify the receiver's content"
	^self propertyValueAt: #content put: aValue with: #contentChanged! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:20'!
holder
	"Answer the holder of the receiver"
	<bewareOf: #holderChanged>
	^self propertyValueAt: #holder! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:20'!
holder: aValue
	"Modify the receiver's holder"
	^self propertyValueAt: #holder put: aValue with: #holderChanged! !

!SqTabButton methodsFor: 'events' stamp: 'minami 3/22/2006 20:18'!
onFired
	<on: fire>

	self holder setActiveContent: self content.
! !

!SqTabButton methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:17'!
release
	self close.! !

!SqTabButton methodsFor: 'private' stamp: 'minami 3/22/2006 19:49'!
setActiveState
	self color: Color white darker.
	self borderColor: Color red.
	self borderWidth: 3.	! !

!SqTabButton methodsFor: 'private' stamp: 'minami 3/22/2006 19:49'!
setNormalState
	self color: Color veryLightGray.
	self borderColor: Color transparent.
	self borderWidth: 1.
	! !

!SqTabButton methodsFor: 'initialize' stamp: 'minami 3/22/2006 19:47'!
setupCostume
	super setupCostume.

	self setNormalState.! !

!CLayoutPolicy methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:56'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

Warning subclass: #SqWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqWarning class methodsFor: 'actions' stamp: 'MU 1/31/2006 19:05'!
warnLog: aMessage
	"SqWarning warnLog: 'this is a test'"
	[self signal: aMessage] on: Exception do: [:ex | ex log]! !

!String methodsFor: '*SqSquare-Core-converting' stamp: 'MU 2/8/2006 10:43'!
asUUID
	^UUID fromString: self! !

EToysProject subclass: #SqEToysProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Experimental'!

SqEToysProject defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqEToysProject methodsFor: 'initialize' stamp: 'minami 3/9/2006 10:51'!
initialize
	super initialize.
	halo userDraw: true.
	halo visible: false.! !

!SqEToysProject methodsFor: 'initialize' stamp: 'minami 2/16/2006 08:34'!
newProject
true ifTrue: [^ super newProject].
	^self newProjectWith: SqEventRecordBoard new.! !

AbUtil subclass: #SqUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

SqUtil class
	instanceVariableNames: 'changerBytes'!

!SqUtil class methodsFor: 'logging' stamp: 'MU 1/31/2006 19:06'!
basicLogError: anError 
	| file |
	[file := FileStream forceNewFileNamed: (anError class name, '.' , self shortImageName , '.' , Time primMillisecondClock asString , '.' , anError identityHash asString , '.log') asFileName.
	Smalltalk timeStamp: file.
	file cr; nextPutAll: anError description asString.
	(thisContext sender sender sender stackOfSize: 30)
		do: [:ctx | 
			file cr.
			ctx printOn: file]]
		ensure: [file
				ifNotNil: [file close]]! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:56'!
byteArrayFromObject: anObject 
"
	SqUtil byteArrayFromObject: #(1 3 5) 
		>> a ByteArray(8 0 0 0 3 4 0 0 0 1 4 0 0 0 3 4 0 0 0 5)
"

	| refStream |
	refStream := ReferenceStream on: (RWBinaryOrTextStream on: (ByteArray new: 4000)).
	refStream nextPut: anObject.
	^ refStream byteStream contents.! !

!SqUtil class methodsFor: 'defining fields' stamp: 'MU 2/27/2006 15:09'!
defineExtraFieldsToSystemClasses
	"SqUtil defineExtraFieldsToSystemClasses"
	self defineExtraFields: #('playerId' 'frozen' 'recording') to: CPlayer! !

!SqUtil class methodsFor: 'defining fields' stamp: 'MU 2/9/2006 12:02'!
defineExtraFields: fields to: aClass 
	| existingFields |
	existingFields := aClass classFields
				collect: [:e | e name].
	fields
		do: [:each | (existingFields includes: each)
				ifFalse: [aClass addField: each]]! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:15'!
ellipseBoundsFromUser
" 
	SqUtil ellipseBoundsFromUser
"
	| originRect gridPoint |
	gridPoint := 1 @ 1.
	originRect := Cursor origin showWhile: [
		((Sensor cursorPoint grid: gridPoint) extent: 0 @ 0)
			newRectFrom: [:f | (Sensor cursorPoint grid: gridPoint) extent: 0 @ 0]].

	^ Cursor corner showWhile: [
		| delay rect buttonStart buttonNow originForm newRect |
		delay := Delay forMilliseconds: 10.
		buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originRect.
		originForm := Form fromDisplay: ActiveWorld bounds.
		
		[buttonNow == buttonStart] whileTrue: [
			delay wait.
			buttonNow := Sensor anyButtonPressed.
			newRect := rect origin corner: (Sensor cursorPoint grid: gridPoint).
			newRect = rect ifFalse: [
				originForm display.
				Display getCanvas
							fillOval: newRect
							color: Color transparent
							borderWidth: 2
							borderColor: Color gray.
							rect := newRect
			].
		].
		originForm display.

		"pay the price for reading the sensor directly ; get this party started "
		Smalltalk isMorphic ifTrue: [
			World activeHand
						newMouseFocus: nil;
					 	showTemporaryCursor: nil;
			 			flushEvents.
		].
		Sensor processEvent: Sensor createMouseEvent.
		rect.
	].! !

!SqUtil class methodsFor: 'logging' stamp: 'MU 2/7/2006 18:42'!
excludeErrorBlock
	^[:err |
		err name = #RmtNetworkError and: [err tag = #connectFailed]
	]! !

!SqUtil class methodsFor: 'class initialization' stamp: 'MU 2/9/2006 11:50'!
initialize
	self initializeAfterLoad! !

!SqUtil class methodsFor: 'class initialization' stamp: 'mu 3/13/2006 14:48'!
initializeAfterLoad
	"SqUtil initializeAfterLoad"
	self defineExtraFieldsToSystemClasses .
	changerBytes _ #() asByteArray! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:15'!
lineBoundsFromUser
" 
	SqUtil lineBoundsFromUser
"
	| originRect gridPoint |
	gridPoint := 1 @ 1.
	originRect := Cursor crossHair showWhile: [
		((Sensor cursorPoint grid: gridPoint) extent: 0 @ 0)
			newRectFrom: [:f | (Sensor cursorPoint grid: gridPoint) extent: 0 @ 0]].

	^ Cursor crossHair showWhile: [
		| delay rect buttonStart buttonNow originForm newRect |
		delay := Delay forMilliseconds: 10.
		buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originRect.
		originForm := Form fromDisplay: ActiveWorld bounds.
		
		[buttonNow == buttonStart] whileTrue: [
			delay wait.
			buttonNow := Sensor anyButtonPressed.
			newRect := rect origin corner: (Sensor cursorPoint grid: gridPoint).
			newRect = rect ifFalse: [
				originForm display.
				Display getCanvas
							line: newRect origin
							to: newRect corner
							width: 2
							color: Color gray.
							rect := newRect
			].
		].
		originForm display.

		"pay the price for reading the sensor directly ; get this party started "
		Smalltalk isMorphic ifTrue: [
			World activeHand
						newMouseFocus: nil;
					 	showTemporaryCursor: nil;
			 			flushEvents.
		].
		Sensor processEvent: Sensor createMouseEvent.
		rect.
	].! !

!SqUtil class methodsFor: 'logging' stamp: 'MU 2/7/2006 18:41'!
logError: anError 
	SqSettings isDebugging ifFalse: [^ self].
	(self excludeErrorBlock value: anError) ifTrue: [^self].
	[self basicLogError: anError]
		on: Error
		do: [:ex | self basicLogError: ex]! !

!SqUtil class methodsFor: 'pen' stamp: 'minami 3/30/2006 15:27'!
newFromPenColor: lineColor width: lineWidth

"
	| p |
	p := SqUtil newFromPenColor: Color red width: 4.
	p openInHand.
"
	| aPen locuses lastPoint locus players group |
	aPen := Pen new.
	aPen color: 0.
	locuses := OrderedCollection new.
	lastPoint := nil.
	locus := nil.

	Cursor marker showWhile: [
		[Sensor yellowButtonPressed] whileFalse: [
			aPen place: Sensor cursorPoint.
			locus isNil ifTrue: [locus := OrderedCollection new: 100].

			[Sensor redButtonPressed] whileTrue: [
				| cursorPoint |
				cursorPoint := Sensor cursorPoint.
				aPen goto: cursorPoint.
				(lastPoint isNil or: [(lastPoint dist: cursorPoint) > 3]) 
					ifTrue: [locus add: cursorPoint].
				lastPoint := cursorPoint.
			].

			locus isEmptyOrNil ifFalse: [
				locuses add: locus.
				locus := nil.
			].
		].
	].
	Sensor waitNoButton.
	Display restore.

	players := OrderedCollection new: locuses size.
	locuses do: [:eachLocus |
		| pp |
		pp := CPolygonPlayer new  
				vertices: eachLocus;
				color: lineColor;
				borderWidth: lineWidth;
				closed: false;
				yourself.
		players add: pp.
	].

	"(players size = 1) ifTrue: [^ players first]."

	group := SqPolygonGroupingPlayer new 
				color: Color transparent; 
				lineColor: lineColor;
				lineWidth: lineWidth;
				yourself.
	group addPlayers: players.
	
	^ group

! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:56'!
objectFromByteArray: aByteArray
"
	SqUtil objectFromByteArray: #(8 0 0 0 3 4 0 0 0 1 4 0 0 0 3 4 0 0 0 5) asByteArray
		>> #(1 3 5)
"

	| anObject refStream |
	refStream := ReferenceStream on: (RWBinaryOrTextStream with: aByteArray) reset.
	anObject := refStream next.
	refStream close.
	^ anObject! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:39'!
objectFromString: aString
"
	SqUtil objectFromString: 'CAAAAAMEAAAAAQQAAAADBAAAAAU='
		>> #(1 3 5)
"

	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := ReferenceStream on: byteStr.
	^oStr next! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 3/27/2006 16:14'!
prepareForClient
	"SqUtil prepareForClient"
	"shutdown any server related objects"

	Smalltalk at: #SqSnapshotDaemon ifPresent:[:p | p default stop].
	Smalltalk at: #SqEventsDumper ifPresent:[:p | p default stop].
	Smalltalk at: #SqConnectionTrimmer ifPresent:[:p | p default stop].

	Smalltalk at: #SqServer ifPresent:[:p | p default stop].
	Smalltalk at: #SqRpcDispatcher ifPresent:[:p | p stop].

	Smalltalk at: #SqClient ifPresent:[:p | p closeAll].

	Smalltalk at: #ElServer ifPresent:[:p | p stopAll].

	Smalltalk at: #SqAudioChatServerFacade ifPresent:[:p | p default stop].
	Smalltalk at: #SqServicePublisher ifPresent:[:p | p stopPublish].
 
! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 4/5/2006 17:19'!
prepareForServer
	"SqUtil prepareForServer"
	"start any server related objects"

	Smalltalk at: #SqSquareDB ifPresent:[:p | p createDb].

	Smalltalk at: #SqSnapshotDaemon ifPresent:[:p | p default start].
	Smalltalk at: #SqEventsDumper ifPresent:[:p | p default start].
	Smalltalk at: #SqConnectionTrimmer ifPresent:[:p | p default start].

	Smalltalk at: #SqServer ifPresent:[:p | 
			p default bootstrapAll; start
	].
	
	Smalltalk at: #SqRpcDispatcher ifPresent:[:p | p start].

	Smalltalk at: #SqAudioChatServerFacade ifPresent:[:p | p default start].
	Smalltalk at: #SqServicePublisher ifPresent:[:p | p startPublish].	


	! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:16'!
rectangleBoundsFromUser
"
	SqUtil rectangleBoundsFromUser
"
	^ Rectangle fromUser! !

!SqUtil class methodsFor: 'extent' stamp: 'minami 2/23/2006 11:50'!
smallFormExtent: aPlayer
	^ self smallFormExtent: aPlayer reduction: 3! !

!SqUtil class methodsFor: 'extent' stamp: 'minami 2/23/2006 11:50'!
smallFormExtent: aPlayer reduction: anInteger
	^ (aPlayer extent // anInteger) asIntegerPoint.! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:38'!
stringFromObject: anObject 
"
	SqUtil stringFromObject: #(1 3 5)
		>> 'CAAAAAMEAAAAAQQAAAADBAAAAAU='
"

	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(ReferenceStream on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents! !

!SqUtil class methodsFor: 'changing class' stamp: 'mu 3/13/2006 14:49'!
toByteArray: aByteArraySubInstance
	
	^aByteArraySubInstance primitiveChangeClassTo: changerBytes! !

!CObjectMaker methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 1/19/2006 16:50'!
parts: aCollection
	parts _ aCollection! !

CObjectMaker subclass: #SqPlayerMaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerMaker class methodsFor: 'actions' stamp: 'mu 3/2/2006 16:05'!
fromParts: parts
	| maker |
	maker _ self new parts: parts.
	^maker next.! !

!SqPlayerMaker methodsFor: 'private-defaults' stamp: 'mu 3/2/2006 16:04'!
newDeserializer
	^SqPlayerDeserializer new! !

RmtBasicMessage subclass: #SqMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqMessage class
	instanceVariableNames: 'typeNumberArray'!

!SqMessage class methodsFor: 'class initialization' stamp: 'minami 1/12/2006 16:50'!
initialize
	super initialize.
	typeNumberArray _ nil! !

!SqMessage class methodsFor: 'accessing' stamp: 'minami 1/18/2006 15:53'!
typeNumberArray
	"SqMessage typeNumberArray"
	typeNumberArray ifNil: [typeNumberArray _ super typeNumberArray , {#negotiate}].
	^typeNumberArray! !

AbSettings subclass: #SqSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:25'!
audioChatPort
	^ self 
		at: #audioChatPort
		ifAbsentPut: [10002]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:25'!
audioChatServerHost
	^ self 
		at: #audioChatServerHost
		ifAbsentPut: ['localhost']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
audioChatServerHost: hostOrIP
	"SqSettings audioChatServerHost: 'qwerty'"
	^ self at: #audioChatServerHost put: hostOrIP asString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
audioCommandPort
	^ self 
		at: #audioChatCommand
		ifAbsentPut: [10001]! !

!SqSettings class methodsFor: 'setting access' stamp: 'minami 1/16/2006 16:26'!
compressThreshold 
	^ 1024! !

!SqSettings class methodsFor: 'private' stamp: 'minami 3/24/2006 16:13'!
createConfiguration

	| config fs |
	config := '
serverHost=127.0.0.1
audioChatServerHost=127.0.0.1
isDebugging=false
isServer=false
isClientOnly=true
playerSerializer=NotODF
'.

	[
		fs := FileDirectory default forceNewFileNamed: self defaultConfigurationFilename.
		fs nextPutAll: config.
	] ensure: [fs close]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
defaultBoardExtent
	^ self 
		at: #defaultBoardExtent
		ifAbsentPut: [800 @ 600]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
defaultBoardExtent: extent
	"SqSettings defaultBoardExtent: 1027@768"
	^ self at: #defaultBoardExtent put: extent! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
eventListenPort
	^ self
		at: #eventListenPort
		ifAbsentPut: [8484]! !

!SqSettings class methodsFor: 'class initialization' stamp: 'mu 3/27/2006 16:54'!
initialize
	super initialize.

	(FileDirectory default fileExists: self defaultConfigurationFilename) ifFalse: [
		self createConfiguration.
	].! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
isClientOnly
	"
	SqSettings isClientOnl
	"


	"^ (Smalltalk includesKey: #SqServer) not"


	"for developing"
	^ self
		at: #isClientOnly
		ifAbsentPut: [false]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
isClientOnly: aBoolean
"
	SqSettings isClientOnly: true.
	SqSettings isClientOnly: false
"

	self deprecated: 'isClient is set automatically'.

	^ self at: #isClientOnly put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
isDebugging
"
	SqSettings isDebugging
"

	^ self
		at: #isDebugging
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:45'!
isDebugging: aBoolean
"
	SqSettings isDebugging: false
"
	SqDebug isDebugging: aBoolean.

	^ self at: #isDebugging put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
isServer
"
	SqSettings isServer
"

	^ self
		at: #isServer
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
isServer: aBoolean
"
	SqSettings isServer: false
"

	^ self at: #isServer put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
omitEventThreshold
	"recommends 30-100"
"
	SqSettings omitEventThreshold
"

	^ self
		at: #omitEventThreshold
		ifAbsentPut: [60]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
omitEventThreshold: milliseconds
"
	SqSettings omitEventThreshold: 60
"

	^ self at: #omitEventThreshold put: milliseconds! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
playerSerializer
	^ self
		at: #playerSerializer
		ifAbsentPut: [#default "#ODF"]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
playerSerializer: aSymbol
"
	SqSettings playerSerializer: #ODF.
	SqSettings playerSerializer: #NotODF.
"

	^ self at: #playerSerializer put: aSymbol! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
rpcListenPort
	^ self
		at: #rpcListenPort
		ifAbsentPut: [8483]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
serverHost
	^ self
		at: #serverHost
		ifAbsentPut: ['localhost']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
serverHost: hostOrIP
	"SqSettings serverHost: 'qwerty'"
	^ self at: #serverHost put: hostOrIP asString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
showReleaseNotes
	^ self
		at: #showReleaseNotes
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
showReleaseNotes: aBoolean
	^ self at: #showReleaseNotes put: aBoolean! !

!SqSettings class methodsFor: 'accessing' stamp: 'MU 2/6/2006 16:47'!
snapshotDirectory
	| dir |
	dir _ FileDirectory default directoryNamed: self snapshotDirectoryName.
	dir assureExistence.
	^dir! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
snapshotDirectoryName
	^ self
		at: #snapshotDirectoryName
		ifAbsentPut: ['board snapshots']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
snapshotDirectoryName: aString
	^ self
		at: #snapshotDirectoryName
		put: aString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/31/2006 11:40'!
useDiscovery
	^ self
		at: #useDiscovery
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/31/2006 11:40'!
useDiscovery: aBoolean
	^ self at: #useDiscovery put: aBoolean == true! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
userId
	^ self
		at: #userId
		ifAbsentPut: ['test']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
userId: aString
	^ self at: #userId put: aString asString! !

AbDebug subclass: #SqDebug
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqDebug class methodsFor: 'accessing' stamp: 'mu 3/27/2006 17:44'!
isDebugging: aBoolean
	aBoolean ifTrue: [AbDebug current: SqDebug] ifFalse: [AbDebug current: nil].
	super isDebugging: aBoolean! !

Error subclass: #SqError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

SqError subclass: #SqOutOfRange
	instanceVariableNames: 'range start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqOutOfRange class methodsFor: 'instance creation' stamp: 'MU 2/23/2006 14:56'!
from: start to: end actualFrom: originalStart to: originalEnd 
	^ self
		from: start
		to: end
		range: (Interval from: originalStart to: originalEnd)! !

!SqOutOfRange class methodsFor: 'instance creation' stamp: 'MU 2/23/2006 13:54'!
from: start to: end range: range 
	^ self new start: start;
		 end: end;
		 range: range;
		 yourself! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
end
	^end! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
end: index
	end _ index! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
range
	^range! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:16'!
range: interval
	range _ interval! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
start
	^start! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
start: index
	start _ index! !

!CWindowCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:58'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CWindowCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:58'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!Exception methodsFor: '*SqSquare-Core-logging' stamp: 'minami 1/17/2006 10:39'!
log
	SqUtil logError: self! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 17:22'!
storeDataOn: aDataStream 
	| cntInstVars |
	cntInstVars := self writtenVarNames size.
	aDataStream beginInstance: self class size: cntInstVars.

	self writtenVarNames
		do: [:nm | 
			| rawValue | 
			rawValue := self instVarNamed: nm.
			self
				storeVariable: rawValue
				named: nm
				on: aDataStream]! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/1/2006 15:44'!
storeVariable: rawValue named: nm on: aDataStream 

	self flag: #todo. "can we omit some fields?"
	"nm = 'partMaker' ifTrue: [aDataStream nextPut: partMaker name]."

	aDataStream nextPut: rawValue! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 17:20'!
writtenVarNames
	^self class  allInstVarNames! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:10'!
byteSize
	^self basicSize * self bytesPerBasicElement! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:11'!
bytesPerBasicElement
	"Answer the number of bytes that each of my basic elements requires.
	In other words:
		self basicSize * self bytesPerBasicElement
	should equal the space required on disk by my variable sized representation."
	^4! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:11'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Swap each pair of bytes (16-bit word), if the current machine is Little Endian.
	Why is this the right thing to do?  We are using memory as a byteStream.  High and low bytes are reversed in each 16-bit word, but the stream of words ascends through memory.  Different from a Bitmap."

	| w b1 b2 b3 b4 |
	SmalltalkImage current  isLittleEndian ifTrue: [
		1 to: self basicSize do: [:i |
			w _ self basicAt: i.
			b1 _ w digitAt: 1.
			b2 _ w digitAt: 2.
			b3 _ w digitAt: 3.
			b4 _ w digitAt: 4.
			w _ (b1 << 24) + (b2 << 16) + (b3 << 8) + b4.
			self basicAt: i put: w.
		]
	].

! !

!StrikeFontSet methodsFor: '*SqSquare-Core' stamp: 'mu 3/6/2006 17:00'!
maxAscii

	^ fontArray first maxAscii
! !

!StrikeFontSet methodsFor: '*SqSquare-Core' stamp: 'mu 3/6/2006 17:01'!
minAscii

	^ fontArray first minAscii
! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 17:12'!
fromCompactBytes: bytes
	| rawBytes parts |
	rawBytes _ bytes uncompressOnDemand.
	parts _ RmtStreamer unstream: rawBytes by: #default.
	^SqPlayerMaker fromParts: parts.
	! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:02'!
instVarFields
	"CObject instVarFields"
	^self classFields select: [:e | e isInstanceVariable]! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/20/2006 17:05'!
objectForDataStream: refStrm 
	self isUniClass
		ifTrue: [| dp | 
			dp := DiskProxy
						global: self originalTheNonMetaClassName
						selector: #uniClassFromOriginal:
						args: {{self originalTheNonMetaClassName. self classVersionID}}. 
			refStrm replace: self with: dp.
			^ dp]
		ifFalse: [^ super objectForDataStream: refStrm]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:03'!
regularFields
	"CObject regularFields"
	^self classFields select: [:e | e isRegularField]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:09'!
serializableInstVarFieldNames
	^self serializableInstVarFields collect: [:each | each name]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:03'!
serializableInstVarFields
	"CObject serializableInstVarFields"
	^self instVarFields select: [:e | e isSerializable]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:09'!
serializableRegularFieldNames
	^self serializableRegularFields collect: [:each | each name]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:04'!
serializableRegularFields
	"CObject serializableRegularFields"
	^self regularFields select: [:e | e isSerializable]! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 16:02'!
uniClassFromOriginal: args 
	"{clsName clsId}"
	| clsName baseClass clsId existingUniClass |
	clsName := args first.
	baseClass := Smalltalk at: clsName asSymbol.
	clsId := args second.
	existingUniClass := baseClass findUniClass: clsId.
	existingUniClass
		ifNil: [| newUniClass | 
			newUniClass := baseClass newUniClass.
			newUniClass classVersionID: clsId.
			^ newUniClass].
	^ existingUniClass! !

!CObject methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/10/2006 16:11'!
asCompactBytes
	| parts |
	parts _ SqPlayerSerializer serialize: self.
	"parts inspect."
	^(RmtStreamer stream: parts by: #default) compressIfMoreThan: SqSettings compressThreshold
	! !

!CObject methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/17/2006 17:46'!
basicSetMyProperties: props
	myProperties _ props! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:31'!
enabledPropertyNames
	^ self propertyNames
		collect: [:e | e asLowercase]
		thenSelect: [:e | e endsWith: 'enabled']! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 15:45'!
enabledPropertyNamesFor: anSqEvent
	"override"
	^self enabledPropertyNames union: anSqEvent defaultEnabledPropertyNames! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:00'!
loadProperty: propName to: newValue 
	self perform: (propName , ':') asSymbol with: newValue forReceive! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 14:57'!
mementoOtherProperties
	| props |
	props _ IdentityDictionary new.
	self mementoOtherPropertyKeys
		do: [:eachKey | props
				at: eachKey
				put: (self propertyValueAt: eachKey)].
	^ props! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 14:57'!
mementoOtherPropertyKeys
	^#(scriptors)! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 15:02'!
mementoRegularFieldKeys
	| theClass keys |
	theClass _ self class.
	keys _ Set new.
	[theClass == CProtoObject]
		whileFalse: [keys addAll: (theClass serializableRegularFields collect: [:e | e name]).
			theClass _ theClass superclass].
	^ keys! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 14:55'!
mementoRegularFields
	| theClass props |
	theClass _ self class.
	props _ IdentityDictionary new.
	[theClass == CProtoObject]
		whileFalse: [theClass serializableRegularFields
				do: [:each | 
					| nm | 
					nm _ each name.
					props
						at: nm
						put: (self propertyValueAt: nm)].
			theClass _ theClass superclass].
	^props! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:38'!
nonNilProperties
	^ self properties
		select: [:each | (self getField: each) notNil]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:38'!
nonNilPropertyNames
	^ self nonNilProperties
		collect: [:each | each name]! !

!CObject methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 16:44'!
objectId
	"TODO: use uuid?"
	^self identityHash! !

!CObject methodsFor: '*SqSquare-Core-serializing-override' stamp: 'mu 3/9/2006 16:04'!
postBuildWith: aMaker 
	"Do any necessary post-construction activity"
	myScripts
		ifNotNil: [myScripts
				do: [:each | each isPaused
						ifFalse: [each resumeScript]]]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:37'!
properties
	^ (self definedFields
		select: [:e | e isRegularField
				and: [e isSerializable]])
		! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:37'!
propertyNames
	"Returns all - override it for performance"
	^ self properties
		collect: [:each | each name]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 15:36'!
propertyNamesFor: anSqEvent
	"override"
	^self propertyNames union: anSqEvent defaultPropertyNames! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/2/2006 16:20'!
readMementoFieldsFrom: deserializer
	"Entry of SqPlayerDeserializer"
	self readMementoFixedFieldsFrom: deserializer.
	self readMementoPropertiesFrom: deserializer

	! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/27/2006 14:53'!
readMementoFixedFieldsFrom: deserializer
	| memento |
	memento := deserializer readField: #scripts.
	memento ifNotNil: [myScripts := memento]
	 ! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:17'!
readMementoOtherProperties: mementoOtherProperties on: deserializer 

	mementoOtherProperties
		at: #scriptors
		put: (self
				scriptorsFromMemento: (mementoOtherProperties at: #scriptors)).

	mementoOtherProperties
		keysAndValuesDo: [:k :v | self propertyValueAt: k put: v]! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:13'!
readMementoPropertiesFrom: deserializer
	| mementoRegularFields mementoOtherProperties |
	mementoRegularFields _ IdentityDictionary new.
	self mementoRegularFieldKeys
		do: [:each | 
			| memento | 
			memento _ deserializer readField: each.
			mementoRegularFields at: each put: memento].
	self readMementoRegularFields: mementoRegularFields on: deserializer.

	mementoOtherProperties _ IdentityDictionary new.
	self mementoOtherPropertyKeys
		do: [:each | 
			| memento | 
			memento _ deserializer readField: each.
			mementoOtherProperties at: each put: memento].
	self readMementoOtherProperties: mementoOtherProperties on: deserializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:14'!
readMementoRegularFields: mementoRegularFields on: deserializer 

	mementoRegularFields
		keysAndValuesDo: [:k :v | self propertyValueAt: k put: v]! !

!CObject methodsFor: '*SqSquare-Core-scripting' stamp: 'mu 3/7/2006 14:29'!
recompileScriptNode: aMethodNode
	"I'm already uniclass, so omit becomeUniClass"

	| newMethod |
	newMethod _ aMethodNode generate: #(0 0 0 0).
	self class addSelectorSilently: aMethodNode selector withMethod: newMethod.
	self signal: #scriptModified with: aMethodNode selector.
	^ aMethodNode selector! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:10'!
saveProperty: propName into: dictionary 
	| val |
	val _ self perform: propName.
	dictionary at: propName put: val forSend.
	^val! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'MU 2/27/2006 15:18'!
scriptorFromSource: aSourceString 
	| tile |
	tile _ ODFCScriptBuilder player: self source: aSourceString.
	^tile ! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/7/2006 14:29'!
scriptorsFromMemento: scriptorsMem 
	^ scriptorsMem
		ifNotNilDo: [:mem | 
			| tiles | 
			tiles _ mem
						collect: [:each | self scriptorFromSource: each].
			tiles do: [:each | self recompileScriptNode: each asParseNode].
			tiles]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 15:46'!
wantsReturnEnabledPropertyNames
	^false! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 14:52'!
wantsReturnPropertyNames
	^false! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/2/2006 14:22'!
writeMementoFieldsOn: serializer
	"Entry of SqPlayerSerializer"
	self writeMementoFixedFieldsOn: serializer.
	self writeMementoPropertiesOn: serializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 12:22'!
writeMementoFixedFieldsOn: serializer
	serializer writeField: #scripts value: myScripts.! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:17'!
writeMementoOtherProperties: otherProperties on: serializer 
	
	otherProperties
		at: #scriptors
		put: (self scriptors
				collect: [:each | each asParseNode asString]).

	otherProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:56'!
writeMementoPropertiesOn: aSerializer 
	"By default, write all serializable regular fields + other properties"
	
	self writeMementoRegularFields: self mementoRegularFields on: aSerializer.
	self writeMementoOtherProperties: self mementoOtherProperties on: aSerializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:39'!
writeMementoRegularFields: fieldMementoProperties on: serializer 
	"By default, writes all fields, - override -"

	fieldMementoProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

CObject subclass: #SqSelectionHighlight
	instanceVariableNames: 'highlightColor color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqSelectionHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field instanceVariable="true" toGet="highlightColor" toSet="highlightColor:">highlightColor</field>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
</fields>'!

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
color
	"Answer the color of the receiver"
	^color! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
color: aValue
	"Modify the receiver's color"
	color := aValue! !

!SqSelectionHighlight methodsFor: 'defaults' stamp: 'minami 1/19/2006 10:31'!
defaultHighlightColor
	^Color red! !

!SqSelectionHighlight methodsFor: 'drawing' stamp: 'minami 1/18/2006 17:44'!
drawOn: aCanvas in: drawingBounds
	| c vExtent hExtent b |
	c _ self color.
	vExtent _ 2@20.
	hExtent _ 20@2.
	b := self targetBounds.

	aCanvas fillRectangle: (b topLeft extent: vExtent) color: c.
	aCanvas fillRectangle: (b topLeft extent: hExtent) color: c.

	aCanvas fillRectangle: (b topRight - (2@0) extent: vExtent) color: c.
	aCanvas fillRectangle: (b topRight - (20@0) extent: hExtent) color: c.

	aCanvas fillRectangle: (b bottomLeft - (0@20) extent: vExtent) color: c.
	aCanvas fillRectangle: (b bottomLeft - (0@2) extent: hExtent) color: c.

	aCanvas fillRectangle: (b bottomRight - (2@20) extent: vExtent) color: c.
	aCanvas fillRectangle: (b bottomRight - (20@2) extent: hExtent) color: c.
! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:31'!
highlightColor
	highlightColor ifNil: [highlightColor _ self defaultHighlightColor].
	^highlightColor! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
highlightColor: aValue
	"Modify the receiver's highlightColor"
	highlightColor := aValue! !

!SqSelectionHighlight methodsFor: 'initializing' stamp: 'minami 1/19/2006 10:28'!
initialize
	super initialize.
	
	self color: self highlightColor.
	! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:32'!
lighterColor
	^self color alpha: 0.5! !

!SqSelectionHighlight methodsFor: 'events' stamp: 'minami 1/19/2006 10:32'!
onTick
	<ticking: 1>

	self color: (
		self color = self highlightColor
			ifTrue:[self lighterColor]
			ifFalse:[self highlightColor]).
! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/18/2006 11:02'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqSelectionHighlight methodsFor: 'private' stamp: 'minami 1/18/2006 16:54'!
targetBounds
	^ self target bounds expandBy: 3! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/18/2006 11:02'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CObject subclass: #SqTestDef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

SqTestDef defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="a" toSet="a:" changeEvent="aChanged">a</field>
	<field toGet="b" toSet="b:" changeEvent="bChanged">b</field>
	<field toGet="c" toSet="c:" changeEvent="cChanged">c</field>
	<field toGet="v" toSet="v:" changeEvent="vChanged">v</field>
</fields>'!

!SqTestDef class methodsFor: 'adding fields' stamp: 'MU 2/9/2006 11:44'!
example1
	"self example1"
	[#('a' 'b' 'c' )
		do: [:each | self addField: each]] on: Error do: [:ex]! !

!SqTestDef class methodsFor: 'adding fields' stamp: 'MU 2/9/2006 12:00'!
example2
	"self example2"
	| existingFields fields |
	existingFields _ self classFields collect: [:e | e name].
	fields _ #('a' 'b' 'c').

	fields do: [:each | 
		(existingFields includes: each) ifFalse: [self addField: each]]	
	! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
a
	"Answer the a of the receiver"
	<bewareOf: #aChanged>
	^self propertyValueAt: #a! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
a: aValue
	"Modify the receiver's a"
	^self propertyValueAt: #a put: aValue with: #aChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
b
	"Answer the b of the receiver"
	<bewareOf: #bChanged>
	^self propertyValueAt: #b! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
b: aValue
	"Modify the receiver's b"
	^self propertyValueAt: #b put: aValue with: #bChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
c
	"Answer the c of the receiver"
	<bewareOf: #cChanged>
	^self propertyValueAt: #c! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
c: aValue
	"Modify the receiver's c"
	^self propertyValueAt: #c put: aValue with: #cChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
v
	"Answer the v of the receiver"
	<bewareOf: #vChanged>
	^self propertyValueAt: #v! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
v: aValue
	"Modify the receiver's v"
	^self propertyValueAt: #v put: aValue with: #vChanged! !

RmtAcceptor subclass: #SqAcceptor
	instanceVariableNames: 'handler accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqAcceptor class
	instanceVariableNames: 'handler'!

!SqAcceptor class methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler
	handler ifNil: [handler _ [:msg | ]].
	^handler ! !

!SqAcceptor class methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:30'!
handler: aBlock
	handler _ aBlock! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:13'!
accessId
	^accessId! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:13'!
accessId: aSqAccessId
	accessId _ aSqAccessId! !

!SqAcceptor methodsFor: 'converting' stamp: 'mu 12/28/2005 20:11'!
asConnector
	^SqConnector with: self socket! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/28/2006 09:09'!
boardId
	^ self accessId boardId! !

!SqAcceptor methodsFor: 'receiving' stamp: 'mu 3/13/2006 11:44'!
handleReceived: messageObject
	messageObject displayForDebug: 2.
	^self handler value: messageObject! !

!SqAcceptor methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler
	handler ifNil: [handler _ self class handler].
	^handler! !

!SqAcceptor methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler: aBlock
	handler _ aBlock! !

!SqAcceptor methodsFor: 'initialize-release' stamp: 'mu 12/28/2005 18:30'!
initialize
	super initialize.
	handler _ [:msg | ]! !

!SqAcceptor methodsFor: 'factory' stamp: 'minami 1/12/2006 12:17'!
messageClass
	^SqMessage! !

!SqAcceptor methodsFor: 'receiving' stamp: 'mu 3/17/2006 12:36'!
process: message 
	message type == #negotiate
		ifTrue: [^ self accessId: message restoreObject].
	super process: message! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/28/2006 09:09'!
userId
	^ self accessId userId! !

!CProjectBuilder methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/2/2006 10:19'!
initialize
	super initialize.
	self allProjects: CCollection new.
	projectShell := self projectShellClass new.
	projectList := self newProjectList.
	self newProject.
	worldMenu := CMenuBar new. "will be clobbered immediately"
	self startScript: #installWorldMenu.! !

CProjectBuilder subclass: #SqProjectBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Experimental'!

SqProjectBuilder defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqProjectBuilder class methodsFor: 'examples' stamp: 'minami 1/20/2006 12:33'!
exOpen
"
	SqProjectBuilder exOpen
"
	SqProjectMorph open: SqProjectBuilder.! !

!SqProjectBuilder methodsFor: 'initializing' stamp: 'minami 1/20/2006 12:25'!
projectShellClass
	^ SqProjectShell! !

!CPrimitiveCostume class methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 12:01'!
readSnapshotByteArray: bytes

	^SqProjectSerializer deserialize: bytes! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/17/2006 11:09'!
attacheAllContentsTo: boardOrSheet
	contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := contents at: i.
		p :=cos player.
		p hasPlayer 
			ifTrue: [p player attacheAllContentsTo: boardOrSheet]
			ifFalse: [p attacheAllContentsTo: boardOrSheet].
	].
! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 13:20'!
detachBoardProperties
	contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := contents at: i.
		p :=cos player.
		p detachBoardProperties.
		p hasPlayer ifTrue: [p player detachBoardProperties].
	].
! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-geometry-parent' stamp: 'minami 2/20/2006 16:27'!
direction: aPoint
	"Indicate the new direction for the receiver"
	| oldDirection newDirection sin cos angle |
	oldDirection := self direction.
	"Compute the delta angle between current and new heading"
	newDirection := [aPoint normalized] on: ZeroDivide do:[:ex| ex return: nil].
	newDirection ifNil:[^oldDirection].

	sin := oldDirection crossProduct: newDirection.
	cos := oldDirection dotProduct: newDirection.

	(sin closeTo: 1.0) ifTrue: [sin := 1.0].
	(cos closeTo: 1.0) ifTrue: [cos := 1.0].

	angle := cos arcCos radiansToDegrees.
	sin < 0.0 ifTrue:[angle := angle negated].
	self rotateBy: angle.
	^aPoint! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-finding' stamp: 'minami 10/26/2005 11:01'!
findPlayerAt: aPoint but: rejectBlockWithOneArg
	"Search the receiver to find the first player located at the given position."
	| aCostume |
	(self containsPoint: aPoint) ifFalse:[^ nil].
	contents size to: 1 by: -1 do:[:i |
		aCostume := contents at: i.
		((aCostume fullContainsPoint: aPoint) 
			and: [(rejectBlockWithOneArg value: aCostume player) not])
			ifTrue: [^ aCostume player].
	].
	^nil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-finding' stamp: 'minami 1/17/2006 14:42'!
findPlayerByUUID: uuid
	contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := contents at: i.
		p :=cos player.
		(p playerId) = uuid ifTrue: [^ p].
		p hasPlayer ifTrue: [(p player findPlayerByUUID: uuid) ifNotNilDo: [:pp | ^ pp]].
	].
	^nil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-testing' stamp: 'minami 12/19/2005 15:24'!
hasPlayer
	^ self player notNil! !

!Form methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:46'!
forSend
	^SqPackedBytes fromObject: self! !

!CCostumeFill methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
readMementoFieldsFrom: deSerializer
	self readFieldsFrom: deSerializer! !

!CCostumeFill methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!ArrayedCollection methodsFor: '*SqSquare-Core-copying' stamp: 'MU 2/16/2006 12:42'!
copyWithAll: col
	^self copyReplaceFrom: self size + 1
		  to: self size
		  with: col! !

!ArrayedCollection methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:35'!
isAssociationCollection
	^self allSatisfy: [:each | each isAssociation]! !

!ArrayedCollection methodsFor: '*SqSquare-Core-copying' stamp: 'MU 2/16/2006 13:28'!
union: col
	^(super union: col) asArray! !

!AsyncScriptMessageSend methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/13/2006 14:38'!
storeDataOn: aDataStream 
	myIsland := nil.
	super storeDataOn: aDataStream! !

!Rectangle methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 12:56'!
intersectionWithLineSegmentFromCenterTo: aPoint 
	"Answer the point, if any, along my border that intersects the  
	line segment between my center and aPoint. Return aPoint if  
	aPoint is inside me or is on my border, else a computed point  
	somewhere along my border."

	| seg |
	(self containsPoint: aPoint)
		ifTrue: [^ aPoint].
	"Answer the set of intersections, if any"
	seg _ LineSegment from: self center to: aPoint.
	self lineSegmentsDo: [ :p1 :p2 | | side int |
		side _ LineSegment from: p1 to: p2.
		int _ side intersectionWith: seg.
		int ifNotNil: [ ^int ].
	].

	^(self center + aPoint) // 2
! !

!Rectangle methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 13:01'!
lineSegmentsDo: aBlock
	"Evaluate aBlock with the receiver's line segments"
	| p |
	aBlock value: origin value: (p _ self topRight).
	aBlock value: p value: corner.
	aBlock value: corner value: (p _ self bottomLeft).
	aBlock value: p value: origin.! !

!LineSegment methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 12:56'!
intersectionWith: anotherSegment
	"Copied from LineIntersections>>intersectFrom:to:with:to:"
	| det deltaPt alpha beta pt1Dir pt2Dir |
	pt1Dir _ end - start.
	pt2Dir _ anotherSegment end - anotherSegment start.
	det _ (pt1Dir x * pt2Dir y) - (pt1Dir y * pt2Dir x).
	deltaPt _ anotherSegment start - start.
	alpha _ (deltaPt x * pt2Dir y) - (deltaPt y * pt2Dir x).
	beta _ (deltaPt x * pt1Dir y) - (deltaPt y * pt1Dir x).
	det = 0 ifTrue:[^nil]. "no intersection"
	alpha * det < 0 ifTrue:[^nil].
	beta * det < 0 ifTrue:[^nil].
	det > 0 
		ifTrue:[(alpha > det or:[beta > det]) ifTrue:[^nil]]
		ifFalse:[(alpha < det or:[beta < det]) ifTrue:[^nil]].
	"And compute intersection"
	^start + (alpha * pt1Dir / (det@det))! !

!CDropShadowHighlight methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:54'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CDropShadowHighlight methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:54'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

TdTimer subclass: #SqConnectionKeeper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnectionKeeper class methodsFor: 'constants' stamp: 'minami 1/13/2006 11:07'!
defaultIntervalSeconds
	^ 10! !

!SqConnectionKeeper class methodsFor: 'constants' stamp: 'minami 1/13/2006 11:07'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqConnectionKeeper methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:34'!
boardClients
	boardClients ifNil: [boardClients _ Set new].
	^boardClients! !

!SqConnectionKeeper methodsFor: 'actions' stamp: 'minami 1/27/2006 17:21'!
keepConnections
	SqClient allInstancesDo: [:c | c keepConnections]! !

!SqConnectionKeeper methodsFor: 'actions' stamp: 'mu 3/8/2006 11:37'!
perform
	self keepConnections! !

TdTimer subclass: #SqConnectionTrimmer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnectionTrimmer class methodsFor: 'constants' stamp: 'minami 1/13/2006 14:42'!
defaultIntervalSeconds
	^ 10! !

!SqConnectionTrimmer class methodsFor: 'constants' stamp: 'minami 1/13/2006 14:42'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqConnectionTrimmer methodsFor: 'actions' stamp: 'mu 3/8/2006 11:36'!
perform
	self trimConnections! !

!SqConnectionTrimmer methodsFor: 'actions' stamp: 'MU 1/20/2006 17:14'!
trimConnections
	SqPassiveConnection closeUnconnected! !

CObjectMakerDeserializer subclass: #SqPlayerDeserializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerDeserializer methodsFor: 'reading' stamp: 'mu 3/2/2006 16:13'!
readContentsOf: anObject
	^anObject readMementoFieldsFrom: self! !

!UUID methodsFor: '*SqSquare-Core-converting' stamp: 'MU 2/8/2006 14:58'!
asUUID
	^self! !

!CPlayer class methodsFor: '*SqSquare-Core-snapshot' stamp: 'mu 3/2/2006 12:01'!
readSnapshotByteArray: bytes

	^SqProjectSerializer deserialize: bytes! !

!CPlayer class methodsFor: '*SqSquare-Core-snapshot' stamp: 'MU 1/19/2006 16:58'!
readSnapshotDataFrom: snapShotStream

	| bytes |
	bytes _ snapShotStream binary contents.
	^self readSnapshotByteArray: bytes! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
addSelectionHighlight
self flag: #minami.
	self addSelectionHighlight: Color red! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
addSelectionHighlight: aColor
	| highlight |
self flag: #minami.
	highlight := CFramingHighlight new.
	highlight border: (CBorder complexAltRaised width: 3; color: aColor).
	highlight name: #selectionHighlight.
	highlight inset: -5.
	self addHighlight: highlight.! !

!CPlayer methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 12:01'!
asSnapshotData
	^SqProjectSerializer serialize: self! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 14:26'!
attacheAllContentsTo: boardOrSheet
	"do nothing"! !

!CPlayer methodsFor: '*SqSquare-Core-initialize-override' stamp: 'mu 3/9/2006 16:21'!
becomeUniClass
	"Make the receiver an instance of a unique class"
	| mgr |	
	super becomeUniClass.
	mgr := Processor activeProject ifNotNilDo: [:p | p scriptManager].
	mgr ifNotNil: [mgr uniClassCreatedFor: self]! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'mu 4/3/2006 16:15'!
detachBoardProperties
	self detachEventRecordBehavior.
	self removePlayerId.
	self removeFrozenFlag.
	self removeRecordingFlag.
	self scale: 1.0.
	costume detachBoardProperties.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/13/2006 16:50'!
detachEventRecordBehavior
	self eventRecordBehavior ifNotNilDo: [:b | b detach]! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 2/13/2006 13:46'!
eventRecordBehavior
	^ self eventBehaviors detect: [:b | b isKindOf: SqEventRecordBehavior] ifNone: [].! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 2/14/2006 15:11'!
eventRecordBoard
	self eventRecordBehavior ifNotNilDo: [:be | ^ be board].
	^ nil.! !

!CPlayer methodsFor: '*SqSquare-Core-finding' stamp: 'minami 10/26/2005 11:03'!
findPlayerAt: aPoint but: rejectBlockWithOneArg
	"Search the receiver to find the first player located at the given position."
	^costume findPlayerAt: aPoint but: rejectBlockWithOneArg! !

!CPlayer methodsFor: '*SqSquare-Core-finding' stamp: 'MU 2/24/2006 13:38'!
findPlayerByUUID: uuid 
	uuid ifNil: [^ nil].
	self playerId = uuid ifTrue: [^ self].
	^ costume findPlayerByUUID: uuid! !

!CPlayer methodsFor: '*SqSquare-Core-finding' stamp: 'minami 2/16/2006 09:05'!
findPlayerOf: clazz
	(self isKindOf: clazz) ifTrue: [^ true].

	self hasPlayer ifFalse: [^ false].	
	^ self player findPlayerOf: clazz! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 15:03'!
freeze
	self propertyValueAt: #frozen put: true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 12/19/2005 15:24'!
hasPlayer
	^ self player notNil! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 2/13/2006 15:48'!
hasPlayerId
	^ self playerId notNil! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 13:41'!
isBoard
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/30/2006 12:16'!
isComplexPlayer
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ true.! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 1/17/2006 15:03'!
isFrozen
	^ (self propertyValueAt: #frozen) == true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 17:15'!
isLabel
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/2/2006 11:42'!
isOnAnyBoard
	self container ifNil: [^ false].
	self container isBoard ifTrue: [^ true].

	^ self container isOnAnyBoard.! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/2/2006 17:31'!
isOnBoard: board
	self container ifNil: [^ false].
	self container == board ifTrue: [^ true].

	^ self container isOnBoard: board! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 1/16/2006 12:50'!
isRecording
	^ self propertyValueAt: #recording ifAbsentPut: [true]! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 17:05'!
isSheet
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-tiles' stamp: 'MU 2/15/2006 16:38'!
linkForSelf
	"Answer a tile representing the receiver"

	| aTile |
	aTile _ SqLinkTile new.
	aTile value: self.
	aTile targetId: self playerId.
	^ aTile
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnBorderChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnDropAcceptFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnFillChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnFlagsChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnGeometryChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnGraphicChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnImageChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnLabelChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnLockFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerCreatedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerRemovedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerSelectedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnRoundCornersChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnTextChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnUnlockFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:42'!
loadProperties: propertyNames from: dic 
	propertyNames
		do: [:nameSymbol | self
				loadProperty: nameSymbol
				to: (dic at: nameSymbol)]! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:01'!
loadProperties: propertyNames from: dic withArgs: args 
	propertyNames
		do: [:nameSymbol | self
				loadProperty: nameSymbol
				to: (dic at: nameSymbol)]! !

!CPlayer methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 16:09'!
mementoEventBehaviors

	| mementoEventBehaviors |
	mementoEventBehaviors _ self eventBehaviors asOrderedCollection.
	mementoEventBehaviors removeAllSuchThat: [:each | each isEventRecordBehavior].
	^mementoEventBehaviors asArray! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 16:44'!
objectId
	^self playerId! !

!CPlayer methodsFor: '*SqSquare-Core-positioning' stamp: 'minami 3/30/2006 12:16'!
onBoardPosition: pos
	| con |
	(self container isBoard) ifTrue: [^ pos].

	((con := self container) isComplexPlayer) ifTrue: [
		^ con onBoardPosition: (con position + pos)
	].

	^ pos! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 4/4/2006 10:55'!
playerId
	"Answer the playerId of the receiver"
	<bewareOf: #playerIdChanged>
	^self propertyValueAt: #playerId! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 4/4/2006 10:55'!
playerId: aValue
	"Modify the receiver's playerId"
	^self propertyValueAt: #playerId put: aValue with: #playerIdChanged! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:02'!
readMementoFixedFieldsFrom: deserializer
	| theClass fields |
	super readMementoFixedFieldsFrom: deserializer.
	myPlayer := deserializer readField: #player ifAbsent:[myPlayer].
	myCostume := deserializer readField: #costume ifAbsent:[myCostume].

	theClass := self class.
	[theClass == CPlayer] whileFalse:[
		fields := theClass serializableInstVarFields.
		fields do: [:each | | nm memento val | nm _ each name.
			 memento _ deserializer readField: nm ifAbsent:[].
			 val _ memento ifNil: [self instVarNamed: nm] ifNotNil: [memento].
			 self instVarNamed: nm put: val.
		].

		theClass := theClass superclass
	].
	! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/16/2006 12:36'!
recordingDisabled
	^ self propertyValueAt: #recording put: false! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/16/2006 12:36'!
recordingEnabled
	^ self propertyValueAt: #recording put: true! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 11:56'!
removeFrozenFlag
	self removePropertyNamed: #frozen.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'MU 2/9/2006 12:39'!
removePlayerId
	self removePropertyNamed: #playerId.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 11:56'!
removeRecordingFlag
	self removePropertyNamed: #recording.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
removeSelectionHighlight
self flag: #minami.
	self removeHighlight: #selectionHighlight.! !

!CPlayer methodsFor: '*SqSquare-Core-opening-override' stamp: 'mu 3/9/2006 16:07'!
resumeTickingScripts
	"Resume all ticking scripts for the receiver and its costume(s)."
	| aPlayer |
	aPlayer := self.
	[aPlayer == nil] whileFalse:[
		aPlayer myScripts do:[:each| (each isTickingScript and: [each isPaused not]) ifTrue:[each resumeScript]].
		aPlayer := aPlayer getCostume.
	].
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnBorderChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnDropAcceptInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnFillChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnFlagsChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnGeometryChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnGraphicChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnImageChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnLabelChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnLockInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 08:51'!
saveOnPlayerCreatedInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnPlayerRemovedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnPlayerSelectedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnRoundCornersChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnTextChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnUnlockInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:42'!
saveProperties: propertyNames into: dic 
	propertyNames do: [:nameSymbol | 
		self saveProperty: nameSymbol into: dic 
	].! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:03'!
saveProperties: propertyNames into: dic withArgs: args
	propertyNames do: [:nameSymbol | 
		self saveProperty: nameSymbol into: dic 
	].! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/10/2006 11:52'!
stopRecordingWhile: aBlock
	[	
		self recordingDisabled.
		aBlock value.
	] ensure: [
		self recordingEnabled.
	]
! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 3/17/2006 12:48'!
title
	^ self name! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 15:02'!
unfreeze
	self propertyValueAt: #frozen put: false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 10:17'!
wantsPropagateGraphicChanged
	^true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 10:16'!
wantsPropagateTextChanged
	^true! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:00'!
writeMementoFixedFieldsOn: aSerializer
	"by default, write all inst vars"
	| theClass fields |
	
	super writeFixedFieldsOn: aSerializer.
	aSerializer writeField: #player value: myPlayer.
	aSerializer writeField: #costume value: myCostume.

	theClass := self class.
	[theClass == CPlayer] whileFalse:[
		fields := theClass serializableInstVarFields.
		fields do: [:each | | nm | nm _ each name. 
			aSerializer writeField: nm value: (self instVarNamed: nm).
		].

		theClass := theClass superclass
	].! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 16:09'!
writeMementoRegularFields: fieldMementoProperties on: serializer 

	fieldMementoProperties at: #eventBehaviors put: self mementoEventBehaviors.

	fieldMementoProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

CPlayer subclass: #SqArrowPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqArrowPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="arrowDirection" toSet="arrowDirection:" changeEvent="arrowDirectionChanged">arrowDirection</field>
	<field toGet="arrowColor" toSet="arrowColor:" changeEvent="arrowColorChanged">arrowColor</field>
	<field toGet="arrowHeadRatio" toSet="arrowHeadRatio:" changeEvent="arrowHeadRatioChanged">arrowHeadRatio</field>
	<field toGet="arrowVertices" toSet="arrowVertices:" changeEvent="arrowVerticesChanged">arrowVertices</field>
</fields>'!

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowColor
	"Answer the arrowColor of the receiver"
	<bewareOf: #arrowColorChanged>
	^self propertyValueAt: #arrowColor! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowColor: aValue
	"Modify the receiver's arrowColor"
	^self propertyValueAt: #arrowColor put: aValue with: #arrowColorChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowDirection
	"Answer the arrowDirection of the receiver"
	<bewareOf: #arrowDirectionChanged>
	^self propertyValueAt: #arrowDirection! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowDirection: aValue
	"Modify the receiver's arrowDirection"
	^self propertyValueAt: #arrowDirection put: aValue with: #arrowDirectionChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:47'!
arrowHeadRatio
	"Answer the arrowHeadRatio of the receiver"
	<bewareOf: #arrowHeadRatioChanged>
	^self propertyValueAt: #arrowHeadRatio! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:47'!
arrowHeadRatio: aValue
	"Modify the receiver's arrowHeadRatio"
	^self propertyValueAt: #arrowHeadRatio put: aValue with: #arrowHeadRatioChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:50'!
arrowVertices
	"Answer the arrowVertices of the receiver"
	<bewareOf: #arrowVerticesChanged>
	^self propertyValueAt: #arrowVertices! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:50'!
arrowVertices: aValue
	"Modify the receiver's arrowVertices"
	^self propertyValueAt: #arrowVertices put: aValue with: #arrowVerticesChanged! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beDownArrow
	self arrowDirection: #down! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beLeftArrow
	self arrowDirection: #left! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beRightArrow
	self arrowDirection: #right! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beUpArrow
	self arrowDirection: #up! !

!SqArrowPlayer methodsFor: 'private' stamp: 'minami 2/24/2006 20:48'!
computeArrowVertices2: drawingBounds
	| offset arrowBounds |
	"drawingBounds printString displayAt: 0@0."
	
	offset := self drawingOffset.
	arrowBounds := (drawingBounds topLeft + offset) corner: (drawingBounds bottomRight - offset).

	self arrowDirection == #up
		ifTrue: [^ {	arrowBounds topCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #down
		ifTrue: [^ {	arrowBounds bottomCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #right
		ifTrue: [^ {	arrowBounds rightCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].

	self arrowDirection == #left
		ifTrue: [^ {	arrowBounds leftCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].
	^ nil! !

!SqArrowPlayer methodsFor: 'private' stamp: 'minami 2/24/2006 20:35'!
computeArrowVertices: drawingBounds
	| offset arrowBounds |
	"drawingBounds printString displayAt: 0@0."
	
	offset := self drawingOffset.
	arrowBounds := (drawingBounds topLeft + offset) corner: (drawingBounds bottomRight - offset).

	self arrowDirection == #up
		ifTrue: [^ {	arrowBounds topCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #down
		ifTrue: [^ {	arrowBounds bottomCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #right
		ifTrue: [^ {	arrowBounds rightCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].

	self arrowDirection == #left
		ifTrue: [^ {	arrowBounds leftCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].
	^ nil! !

!SqArrowPlayer methodsFor: 'drawing' stamp: 'minami 2/24/2006 20:51'!
drawArrowOn: aCanvas in: drawingBounds

	self arrowVertices ifNil: [self arrowVertices: (self computeArrowVertices: drawingBounds)].
	aCanvas drawPolygon: self arrowVertices fillStyle: self arrowColor borderWidth: 0 borderColor: self arrowColor! !

!SqArrowPlayer methodsFor: 'constants' stamp: 'minami 2/24/2006 20:35'!
drawingOffset
	^ 3@3! !

!SqArrowPlayer methodsFor: 'drawing' stamp: 'minami 2/24/2006 20:43'!
drawOn: aCanvas in: drawingBounds
	super costume drawOn: aCanvas in: drawingBounds.
	self drawArrowOn: aCanvas in: drawingBounds.
! !

!SqArrowPlayer methodsFor: 'initialize' stamp: 'minami 2/24/2006 20:50'!
initialize
	super initialize.

	self userDraw: true.
	self beRightArrow.
	self arrowHeadRatio: 0.3.
	self arrowColor: Color black.
	self arrowVertices: nil.
! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:41'!
onArrowColorChanged
	<on: arrowColorChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:42'!
onArrowDirectionChanged
	<on: arrowDirectionChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:47'!
onArrowHeadRatioChanged
	<on: arrowHeadRatioChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:53'!
onGeometryChanged
	<on: geometryChanged>

	self arrowVertices: nil.
	self invalidate.! !

CPlayer subclass: #SqConstraintPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqConstraintPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="connector" toSet="connector:" changeEvent="connectorChanged">connector</field>
	<field toGet="edge" toSet="edge:" changeEvent="edgeChanged">edge</field>
	<field toGet="constraintPoint" toSet="constraintPoint:" changeEvent="constraintPointChanged">constraintPoint</field>
	<field toGet="constraintType" toSet="constraintType:" changeEvent="constraintTypeChanged">constraintType</field>
</fields>'!

!SqConstraintPlayer methodsFor: 'menu' stamp: 'minami 10/31/2005 13:32'!
addConstraintMenuTo: aMenu
	| menu addMenuBlock |
	menu := CMenu new.
	menu label: 'Constraint Point'.

	(menu
		add: #free
		target: self
		action: #setTypeFree
		arguments: {}
	) checked: (self constraintType == #free).

	addMenuBlock := [:label :pointSymbol | 
			| menuItem | 
			menuItem := menu
						add: label
						target: self
						action: #setTypeFixAt:
						arguments: {pointSymbol}.
			menuItem
				checked: (self constraintType == #fix and: [self constraintPoint == pointSymbol])].
	#(#topLeft #topCenter #topRight #leftCenter #center #rightCenter #bottomLeft #bottomCenter #bottomRight)
		do: [:menuSpec | 
			addMenuBlock value: menuSpec value: menuSpec].

	aMenu
		ifNotNil: [aMenu add: 'Constraint Point' subMenu: menu]! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 11/1/2005 13:04'!
computePos

	| newPos targetBounds otherBounds |

	self target ifNil: [^ nil].
	(constraintType == #fix) ifTrue: [^ self target bounds perform: self constraintPoint].

	targetBounds := self target globalBounds.
	otherBounds := self otherSide globalBounds.

	newPos := targetBounds intersectionWithLineSegmentFromCenterTo: otherBounds center.
	
	^ newPos asIntegerPoint
! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:39'!
connector
	"Answer the connector of the receiver"
	<bewareOf: #connectorChanged>
	^self propertyValueAt: #connector! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:39'!
connector: aValue
	"Modify the receiver's connector"
	^self propertyValueAt: #connector put: aValue with: #connectorChanged! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/26/2005 12:42'!
connector: aConnector edge: aSymbol
	self connector: aConnector.
	self edge: aSymbol.

	self startScript: #destroy when: {self connector. #close}.

	self startScript: #privUpdatePosition when: {self otherSide. #geometryChanged}.
	"updatePosition does not work, why?"! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 11:55'!
constraintPoint
	"Answer the constraintPoint of the receiver"
	<bewareOf: #constraintPointChanged>
	^self propertyValueAt: #constraintPoint! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 11:55'!
constraintPoint: aValue
	"Modify the receiver's constraintPoint"
	^self propertyValueAt: #constraintPoint put: aValue with: #constraintPointChanged! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 12:06'!
constraintType
	"Answer the constraintType of the receiver"
	<bewareOf: #constraintTypeChanged>
	^self propertyValueAt: #constraintType! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 12:06'!
constraintType: aValue
	"Modify the receiver's constraintType"
	^self propertyValueAt: #constraintType put: aValue with: #constraintTypeChanged! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:41'!
edge
	"Answer the edge of the receiver"
	<bewareOf: #edgeChanged>
	^self propertyValueAt: #edge! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:41'!
edge: aValue
	"Modify the receiver's edge"
	^self propertyValueAt: #edge put: aValue with: #edgeChanged! !

!SqConstraintPlayer methodsFor: 'menu' stamp: 'minami 10/31/2005 14:38'!
getConstraintMenu
	| aMenu |
	aMenu _ CMenu new.
	aMenu label: 'Constraint Menu'.
	self addConstraintMenuTo: aMenu.
	^ aMenu! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/31/2005 12:37'!
initialize
	super initialize.
	
	constraintType := #free. "#fix, #free"

	"if constraintType == #free, constraintPoint ignored."
	constraintPoint := #center.	"#topLeft, #topCenter, #topRight, 
								#leftCenter, #center, #rightCenter,
								#bottomLeft, #bottomCenter, #bottomRight"! !

!SqConstraintPlayer methodsFor: 'events' stamp: 'minami 2/20/2006 12:07'!
onDropAccept: obj 
	| aPlayer |
	<on: #dropAccept>

	aPlayer := self world
				findPlayerAt: self hand globalPosition
				but: [:p | (p isKindOf: SqConstraintPlayer)
						or: [p == self connector]].
	self setNewTarget: aPlayer! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/26/2005 12:24'!
otherSide
	^ self edge == #from
		ifTrue: [self connector toTarget]
		ifFalse: [self connector fromTarget]! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 10/26/2005 12:39'!
privUpdatePosition

	self updatePosition! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'mu 3/17/2006 11:49'!
setNewTarget: aPlayer
	self stopScript: #updatePosition. 
	
	self target: aPlayer.
	aPlayer ifNotNil: [
		self startScript: #updatePosition when: {self target. #geometryChanged}.
	].! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/31/2005 13:48'!
setTypeFixAt: symbol
	self constraintType: #fix.
	self constraintPoint: symbol.! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/31/2005 13:20'!
setTypeFree
	self constraintType: #free! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/31/2005 12:40'!
setupCostume
	super setupCostume.

	self extent: 15@15.
	self color: Color red.
	self borderWidth: 0.

	self
		startScript: [self getConstraintMenu openAt: self hand position]
		when: {self. #yellowButtonDown}! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:03'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:03'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 10/26/2005 12:34'!
updatePosition
	self computePos ifNotNilDo: [:pos | self position: pos].! !

CPlayer subclass: #SqEventRecordBoard
	instanceVariableNames: 'boardClient isHeadless isRecovering headlessBoardId eventPlayer trailStartPos isSelectionStarted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqEventRecordBoard defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="isRecording" toSet="isRecording:" changeEvent="isRecordingChanged">isRecording</field>
	<field toGet="highlights" toSet="highlights:" changeEvent="highlightsChanged">highlights</field>
	<field instanceVariable="true" serializable="false" toGet="boardClient" toSet="boardClient:" color="FFFF00">boardClient</field>
	<field instanceVariable="true" toGet="isHeadless" toSet="isHeadless:">isHeadless</field>
	<field instanceVariable="true" serializable="false" toGet="isRecovering" toSet="isRecovering:" color="FFFF00">isRecovering</field>
	<field instanceVariable="true" toGet="headlessBoardId" toSet="headlessBoardId:">headlessBoardId</field>
	<field instanceVariable="true" toGet="eventPlayer" toSet="eventPlayer:">eventPlayer</field>
	<field instanceVariable="true" serializable="false" toGet="trailStartPos" toSet="trailStartPos:">trailStartPos</field>
	<field instanceVariable="true" toGet="isSelectionStarted" toSet="isSelectionStarted:">isSelectionStarted</field>
</fields>'!

!SqEventRecordBoard class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 17:04'!
on: aSqBoardClient 
	^ super new boardClient: aSqBoardClient; yourself! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:19'!
accessId
	self isHeadless ifTrue: [^nil].
	^ self boardClient ifNotNilDo: [:bc | bc accessId]! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 4/3/2006 16:57'!
addPlayer: aPlayer
	| tfm |
	(self isIn: aPlayer) ifTrue: [^ aPlayer signal: #dropReject].
	aPlayer isDropAcceptable ifFalse: [^ aPlayer signal: #dropReject].

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.
	self add: aPlayer.
	aPlayer signal: #dropAccept with: self.
	self signal: #contentsChanged.

	self isRecording ifFalse: [^ self].

	aPlayer hasPlayerId ifFalse: [
		aPlayer playerId: UUID new.
		self attachEventRecordBehavior: aPlayer.
		self recordCreateEventFor: aPlayer.
		self isHeadless ifFalse: [self waitTick]. 
		self recordDefaultStatus: aPlayer.
		self attachBoardPropertiesTo: aPlayer.
		aPlayer attacheAllContentsTo: self
	].
! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 4/3/2006 17:04'!
attachBoardPropertiesTo: aPlayer
	aPlayer scale: 1! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'MU 2/24/2006 13:08'!
attachEventRecordBehavior: aPlayer
	| behavior |
	behavior := self eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: self.
! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:57'!
boardClient
	"Answer the boardClient of the receiver"
	^boardClient! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/9/2006 13:07'!
boardClient: aValue
	"Modify the receiver's boardClient"
	boardClient := aValue! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:20'!
boardId
	self isHeadless ifTrue: [^self headlessBoardId].
	^ self accessId ifNotNilDo: [:ac | ac boardId]! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/17/2006 13:01'!
boardName
	^ self boardClient boardName! !

!SqEventRecordBoard methodsFor: 'defaults' stamp: 'minami 1/27/2006 17:26'!
client
	^ SqClient userId: self boardClient! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 4/4/2006 16:38'!
destroy
	self release! !

!SqEventRecordBoard methodsFor: 'drawing' stamp: 'minami 1/18/2006 18:01'!
drawOn: aCanvas in: drawingBounds
	super drawOn: aCanvas in: drawingBounds.

	self highlights do: [:h | 
		h drawOn: aCanvas in: drawingBounds.
	].
	self invalidate
! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:52'!
eventPlayer
	eventPlayer ifNil: [eventPlayer _ SqEventPlayer on: self].
	^eventPlayer! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:49'!
eventPlayer: aValue
	"Modify the receiver's eventPlayer"
	eventPlayer := aValue! !

!SqEventRecordBoard methodsFor: 'defaults' stamp: 'minami 1/19/2006 12:23'!
eventRecordBehaviorClass
	^ SqEventRecordBehavior! !

!SqEventRecordBoard methodsFor: 'setting extent' stamp: 'mu 3/17/2006 14:38'!
extent: newExtent 
	| smallBounds |
	super extent: newExtent.
	smallBounds _ self bounds insetBy: 30.
	self elements
		do: [:each | (bounds containsPoint: each position)
				ifFalse: [each
						position: (each position adhereTo: smallBounds)]]! !

!SqEventRecordBoard methodsFor: 'highlight' stamp: 'minami 2/10/2006 11:39'!
freezePlayer: pId from: userId
	| highlight |
	player := self findPlayerByUUID: pId.
	player ifNil: [^ nil].

	player freeze.

	highlight _ SqSelectionHighlight new.
	highlight target: player.

	self highlights removeKey: userId ifAbsent: [].
	self highlights at: userId put: highlight.

	self invalidate.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 17:02'!
hasMoreEventsToPlay
	eventPlayer ifNil: [^false].
	^eventPlayer hasMoreEventsToPlay! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/6/2006 17:03'!
headlessBoardId
	"Answer the headlessBoardId of the receiver"
	^headlessBoardId! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/6/2006 17:03'!
headlessBoardId: aValue
	"Modify the receiver's headlessBoardId"
	headlessBoardId := aValue! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 2/8/2006 14:33'!
hideHalo
	self project halo target ifNotNil:[self project halo target: nil].! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 1/18/2006 16:23'!
highlights
	"Answer the highlights of the receiver"
	<bewareOf: #highlightsChanged>
	^self propertyValueAt: #highlights! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 1/18/2006 16:23'!
highlights: aValue
	"Modify the receiver's highlights"
	^self propertyValueAt: #highlights put: aValue with: #highlightsChanged! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:20'!
imageId
	self isHeadless ifTrue: [^nil].
	^ self accessId  ifNotNilDo: [:ac | ac imageId]! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'minami 3/31/2006 12:20'!
initialize
	super initialize.
	self userDraw: true.

	self stopScript: #onGeometryChanged.
	isRecording := true.

	highlights := Dictionary new.

	isHeadless := false.
	isSelectionStarted := false.

	self resetTrailStartPos.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/16/2006 13:41'!
isBoard
	^true! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ false.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/6/2006 17:00'!
isHeadless
	isHeadless ifNil: [isHeadless _ false].
	^isHeadless! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/6/2006 17:00'!
isHeadless: aValue
	"Modify the receiver's isHeadless"
	isHeadless := aValue! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 12/20/2005 11:32'!
isRecording
	"Answer the isRecording of the receiver"
	<bewareOf: #isRecordingChanged>
	^self propertyValueAt: #isRecording! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 12/20/2005 11:32'!
isRecording: aValue
	"Modify the receiver's isRecording"
	^self propertyValueAt: #isRecording put: aValue with: #isRecordingChanged! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 17:06'!
isRecovering
	"Answer the isRecovering of the receiver"
	isRecovering ifNil: [isRecovering _ false].
	^isRecovering! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 16:26'!
isRecovering: aValue
	"Modify the receiver's isRecovering"
	isRecovering := aValue! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
isSelectionStarted
	"Answer the isSelectionStarted of the receiver"
	^isSelectionStarted! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
isSelectionStarted: aValue
	"Modify the receiver's isSelectionStarted"
	isSelectionStarted := aValue! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 19:59'!
moveBoardView: deltaPoint

	self scroller horizontalPos: (self scroller horizontalPos + deltaPoint x) asInteger.
	self scroller verticalPos: (self scroller verticalPos + deltaPoint y) asInteger.
! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 1/17/2006 15:15'!
onDragDrop: aPlayer 
	<on: dragDrop>

	self addPlayer: aPlayer.
	aPlayer unfreeze.! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/31/2006 12:10'!
onKeyDown: evt
	<on: keyDown>
	
	evt shiftPressed ifTrue: [
		self mouseCursor: Cursor normal
	].! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/31/2006 12:18'!
onMouseDown: evt
	| draggee |
	<on: mouseDown>

	draggee := self findDraggablePlayerAt: self cursorPoint.

	draggee ifNotNilDo: [:d |
		d isFrozen ifTrue: [^ self].
		d onDrag
	].

	self removeKeyboardFocus.
	self hideHalo! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/29/2006 20:20'!
onMouseEnter
	<on: mouseEnter>

	self setRightCorsor! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/29/2006 20:20'!
onMouseMove
	<on: mouseMove>

	self setRightCorsor! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/31/2006 12:30'!
onRedButtonDown: evt
	<on: redButtonDown>

	evt shiftPressed ifTrue: [
		self mouseCursor: Cursor normal.
		^ self startSelection: evt.
	].

	self trailStartPos: (self globalToLocal: self hand position).

	self trailBoardView! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/31/2006 12:22'!
onRedButtonMove
	<on: redButtonMove>

	self isSelectionStarted ifTrue: [^ self mouseCursor: Cursor normal].

	self trailBoardView! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 3/31/2006 12:22'!
onRedButtonUp
	<on: redButtonUp>

	self isSelectionStarted ifTrue: [self stopSelection].

	self setRightCorsor.
	self resetTrailStartPos! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'MU 2/10/2006 17:56'!
play
	eventPlayer ifNil: [^self].
	self eventPlayer play! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'MU 2/8/2006 16:40'!
playReverse
	self eventPlayer playReverse! !

!SqEventRecordBoard methodsFor: 'copying' stamp: 'minami 1/16/2006 11:26'!
postCopy
	super postCopy.
Transcript cr; show: thisContext printString.! !

!SqEventRecordBoard methodsFor: 'printing' stamp: 'MU 2/9/2006 17:27'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	eventPlayer ifNotNilDo: [:ep | aStream nextPutAll: ('last ev-> ', ep lastEvent asString)].
	aStream nextPutAll: ')'! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 3/17/2006 11:21'!
recordCreateEventFor: aPlayer
	| event  |
	event := SqPlayerEventFactory
				createEvent: #playerCreated
				target: aPlayer
				accessId: self accessId
				args: #().
	self recordEvent: event.! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'minami 12/27/2005 13:44'!
recordDefaultStatus: aPlayer

	aPlayer signal: #flagsChanged.
	aPlayer signal: #fillChanged.
	aPlayer signal: #geometryChanged.
	aPlayer signal: #borderChanged.
	aPlayer signal: #textChanged.
	aPlayer signal: #graphicChanged.
! !

!SqEventRecordBoard methodsFor: 'sending events' stamp: 'MU 2/13/2006 13:28'!
recordEvent: eventRecord
	self isRecovering ifTrue: [^self].
	self boardClient ifNotNilDo: [:bc |  bc recordEvent: eventRecord]! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 4/4/2006 16:38'!
release
	eventPlayer ifNotNilDo: [:evp | evp destroy].
	boardClient ifNotNilDo: [:bc | bc destroy].
	highlights ifNotNilDo: [:hi | hi do: [:each | each destroy]].

	isRecording _ highlights _ boardClient _ isHeadless _ isRecovering _ headlessBoardId _ eventPlayer _ nil! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 2/8/2006 14:32'!
removeKeyboardFocus
	self world hand keyboardFocus ifNotNil:[self world hand keyboardFocus: nil].! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 20:23'!
resetTrailStartPos
	self trailStartPos: nil! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'MU 2/14/2006 15:05'!
scrollBy: deltaPoint
	| scroller |
	scroller _ self scroller.
	scroller ifNil: [^nil].
	scroller horizontalPos: scroller horizontalPos + deltaPoint x.
	scroller verticalPos: scroller verticalPos + deltaPoint y.
	^scroller! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/9/2006 15:09'!
scroller
	| cont |
	cont := self container.
	[cont isNil
		or: [cont isMemberOf: SqBoardWindow]
		or: [cont isMemberOf: SqBoardTray]]
		whileFalse: [cont := cont container].

	^ ((cont isMemberOf: SqBoardWindow) or: [cont isMemberOf: SqBoardTray])
		ifTrue: [cont]! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/14/2006 16:36'!
scrollingCenter
	^ (self viewPort center
		+ (Point x: self scroller hBar value y: self scroller vBar value)) asIntegerPoint! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/15/2006 14:24'!
scrollTo: newPosition
	| scroller |
	scroller _ self scroller.
	scroller ifNil: [^self].
	scroller horizontalPos: newPosition x.
	scroller verticalPos: newPosition y
	! !

!SqEventRecordBoard methodsFor: 'setting extent' stamp: 'mu 3/17/2006 14:20'!
setExtent: newExtent
	self boardClient ifNil: [^self].
	self extent: newExtent.
	self boardClient setExtent: newExtent.
	! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 20:20'!
setRightCorsor
	| draggee |
	draggee := self findDraggablePlayerAt: self cursorPoint.

	draggee 
		ifNil: [self mouseCursor: CCursorLibrary handCursor.]
		ifNotNil: [self mouseCursor: Cursor normal]
! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 3/16/2006 17:01'!
setupCostume
	super setupCostume.

	self clipping: true.
	self borderStyle: #raised.
	self borderWidth: 0.

	self color := Color r:0.937 g: 0.937 b: 0.937.
	"self borderStyle: #inner."

	self extent: SqSettings defaultBoardExtent! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 12/27/2005 15:13'!
smallForm
	^ self makeIcon: self smallFormExtent! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 12/27/2005 16:56'!
smallFormExtent
	^ SqUtil smallFormExtent: self! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 2/23/2006 11:54'!
smallFormExtent: reduction
	^ SqUtil smallFormExtent: self reduction: reduction! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 2/23/2006 11:54'!
smallForm: reduction
	^ self makeIcon: (self smallFormExtent: reduction)! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/31/2006 12:33'!
startSelection: evt 
	self isSelectionStarted: true.
	SqSelectionPlayer new extent: 0 @ 0;
		 addResizeHandle;
		 openAt: (self localToGlobal: evt position);
		 yourself! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'MU 2/17/2006 13:34'!
stepScrollToward: aPlayer
	aPlayer ifNil: [^false].
	(aPlayer isOnBoard: self) ifFalse: [^false].

	self stepScrollTo: (aPlayer onBoardPosition: aPlayer position) by: 7.
	^true
! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/16/2006 09:44'!
stepScrollToward: aPlayer by: step
	aPlayer ifNil: [^self].
	self stepScrollTo: (aPlayer onBoardPosition: aPlayer position) by: step
! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/15/2006 14:55'!
stepScrollTo: targetPosition
	self stepScrollTo: targetPosition by: 7! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 3/2/2006 11:12'!
stepScrollTo: targetPosition by: step
	| scroller vpExtent distPos delta |
	(scroller := self scroller) ifNil: [^ self].

	vpExtent := self viewPort extent.

	distPos := ((targetPosition x - (vpExtent x // 2)) @ (targetPosition y - (vpExtent y // 2))) asIntegerPoint.
	delta := (distPos - scroller currentPos) // step.

	step timesRepeat: [
		scroller currentPos: (scroller currentPos + delta).
		self isHeadless ifFalse: [self waitTick]. 
	].
	scroller currentPos: distPos
! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'MU 2/8/2006 11:54'!
stop
	self eventPlayer stop! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/31/2006 12:15'!
stopSelection
	self isSelectionStarted: false! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:16'!
title
	^ self boardName! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 20:25'!
trailBoardView
	| handPos delta |
	self trailStartPos ifNil: [^ self].

	self mouseCursor: CCursorLibrary fistCursor.
	handPos := self globalToLocal: self hand position.
	delta := self trailStartPos - handPos.
	self moveBoardView: delta.
! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
trailStartPos
	"Answer the trailStartPos of the receiver"
	^trailStartPos! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
trailStartPos: aValue
	"Modify the receiver's trailStartPos"
	trailStartPos := aValue! !

!SqEventRecordBoard methodsFor: 'highlight' stamp: 'minami 2/10/2006 11:39'!
unfreezePlayer: pId from: userId

	player := self findPlayerByUUID: pId.
	player ifNil: [^ nil].

	player unfreeze.
	self highlights removeKey: userId ifAbsent: [].

	self invalidate.! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:20'!
userId
	self isHeadless ifTrue: [^nil].
	^ self accessId ifNotNilDo: [:ac | ac userId] ! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'MU 2/14/2006 12:05'!
viewPort
	| scrollPane |
	scrollPane _ self container ifNotNilDo: [:con | con container].
	^scrollPane ifNotNilDo: [:sc | sc bounds].! !

!SqEventRecordBoard methodsFor: 'serializing' stamp: 'MU 2/15/2006 15:20'!
writeFieldsOn: aSerializer
	boardClient _ nil.
	super writeFieldsOn: aSerializer! !

CPlayer subclass: #SqGroupingPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqGroupingPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="attachedPlayers" toSet="attachedPlayers:" changeEvent="attachedPlayersChanged">attachedPlayers</field>
</fields>'!

!SqGroupingPlayer class methodsFor: 'instance creation' stamp: 'minami 3/30/2006 09:47'!
fromUser
	| inst |
	inst := self new.
	inst open.
	inst fromUser.
	^ inst! !

!SqGroupingPlayer methodsFor: 'adding' stamp: 'minami 4/4/2006 12:25'!
addPlayers: players
	| tmpBounds |
	self waitTick.
	tmpBounds := self bounds.

	players do: [:p |
		| t b l r |
		t := ((p bounds top - tmpBounds top) / tmpBounds height) asFloat.
		b := ((p bounds bottom - tmpBounds top) / tmpBounds height) asFloat.
		l := ((p bounds left - tmpBounds left) / tmpBounds width) asFloat.
		r := ((p bounds right - tmpBounds left) / tmpBounds width) asFloat.
		p layoutFrame: (l@t corner: r@b).
		p hResizing: #spaceFill.
		p vResizing: #spaceFill.
		self add: p.
		self attachedPlayers add: p.
	].
	^ players
! !

!SqGroupingPlayer methodsFor: 'adding' stamp: 'minami 3/30/2006 04:09'!
addPlayer: aPlayer
	self addPlayers: { aPlayer }! !

!SqGroupingPlayer methodsFor: 'accessing' stamp: 'minami 4/3/2006 14:48'!
attachedPlayers
	"Answer the attachedPlayers of the receiver"
	<bewareOf: #attachedPlayersChanged>
	^self propertyValueAt: #attachedPlayers! !

!SqGroupingPlayer methodsFor: 'accessing' stamp: 'minami 4/3/2006 14:48'!
attachedPlayers: aValue
	"Modify the receiver's attachedPlayers"
	^self propertyValueAt: #attachedPlayers put: aValue with: #attachedPlayersChanged! !

!SqGroupingPlayer methodsFor: 'initialization' stamp: 'minami 4/3/2006 14:49'!
initialize
	super initialize.
	
	attachedPlayers := OrderedCollection new.! !

!SqGroupingPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 12:17'!
isComplexPlayer
	^ true! !

!SqGroupingPlayer methodsFor: 'initialization' stamp: 'minami 3/30/2006 09:46'!
setupCostume
	super setupCostume.

	self extent: 0@0.
	self borderWidth: 5.
	self borderColor: Color red.
	self color: (Color gray alpha: 0.3).

	self layout: CProportionalLayout new.

! !

SqGroupingPlayer subclass: #SqPolygonGroupingPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqPolygonGroupingPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="lineColor" toSet="lineColor:" changeEvent="lineColorChanged">lineColor</field>
	<field toGet="lineWidth" toSet="lineWidth:" changeEvent="lineWidthChanged">lineWidth</field>
</fields>'!

!SqPolygonGroupingPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 15:27'!
containsPoint: aPoint 
	self costume contents
		do: [:each | (each containsPoint: aPoint)
				ifTrue: [^ true]].
	^ false
! !

!SqPolygonGroupingPlayer methodsFor: 'contents access' stamp: 'mu 4/4/2006 17:26'!
contentsInfo
	| col |
	col := OrderedCollection new.
	self elements do: [:each | col add: {each vertices. each bounds origin}].
	^ col.! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineColor
	"Answer the lineColor of the receiver"
	<bewareOf: #lineColorChanged>
	^self propertyValueAt: #lineColor! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineColor: aValue
	"Modify the receiver's lineColor"
	^self propertyValueAt: #lineColor put: aValue with: #lineColorChanged! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineWidth
	"Answer the lineWidth of the receiver"
	<bewareOf: #lineWidthChanged>
	^self propertyValueAt: #lineWidth! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineWidth: aValue
	"Modify the receiver's lineWidth"
	^self propertyValueAt: #lineWidth put: aValue with: #lineWidthChanged! !

!SqPolygonGroupingPlayer methodsFor: 'load/save' stamp: 'minami 3/30/2006 14:53'!
loadOnPlayerCreatedFrom: dic withArgs: args
	| contentsInfo polygons |
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(lineColor lineWidth) from: dic.

	contentsInfo := dic at: #contentsInfo ifAbsent: [].

	polygons := contentsInfo collect: [:infoArray |
		CPolygonPlayer new  
				vertices: infoArray first;
				color: self lineColor;
				borderWidth: self lineWidth;
				position: infoArray second;
				closed: false;
				yourself.
	].
	self addPlayers: polygons.! !

!SqPolygonGroupingPlayer methodsFor: 'load/save' stamp: 'minami 3/30/2006 14:38'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(lineColor lineWidth contentsInfo) into: dic 
	! !

SqGroupingPlayer subclass: #SqSelectionPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqSelectionPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="resizeHandle" toSet="resizeHandle:" changeEvent="resizeHandleChanged">resizeHandle</field>
</fields>'!

!SqSelectionPlayer class methodsFor: 'instance creation' stamp: 'minami 3/30/2006 15:34'!
fromUser
	| bounds |
	bounds _ Rectangle fromUser.
	^ self new extent: bounds extent;
		 openAt: bounds origin;
		 yourself! !

!SqSelectionPlayer methodsFor: 'menu' stamp: 'minami 4/4/2006 11:14'!
addGroupingMenuMenuOn: aMenu
	| menu |
	menu := CMenu new.
	
	self coveredPlayers size < 2 
		ifTrue: [menu add: 'group' target: self action: #group disabled: true]
		ifFalse: [menu add: 'group' target: self action: #group argument: #()].

	self attachedPlayers isEmptyOrNil 
		ifTrue: [menu add: 'ungroup' target: self action: #ungroup disabled: true]
		ifFalse: [menu add: 'ungroup' target: self action: #ungroup argument: #()].

	aMenu add: 'grouping' subMenu: menu.
	^aMenu! !

!SqSelectionPlayer methodsFor: 'handle' stamp: 'minami 4/4/2006 11:11'!
addResizeHandle
	| ellipse |
	self resizeHandle ifNotNil: [^ self].

	ellipse := CEllipsePlayer new 
				extent: 10@10; 
				borderWidth: 2;
				yourself.
	
	self resizeHandle: ellipse.
	self resizeHandle openAt: self bottomRight.

	self resizeHandle 
		startScript: [self onResizeHandleGeometryChanged] 
		when: {self resizeHandle. #geometryChanged}.
"
	self resizeHandle 
		startScript: [self onResizeHandleUp] 
		when: {self resizeHandle. #mouseUp}.
"! !

!SqSelectionPlayer methodsFor: 'adding' stamp: 'mu 4/4/2006 17:26'!
addSelectedPlayers
	| col |
	col _ OrderedCollection new.
	self container elements
		do: [:aPlayer | (self bounds containsRect: aPlayer bounds)
				ifTrue: [col add: aPlayer]].
	self addPlayers: col! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 4/4/2006 11:50'!
attacheAllContentsTo: boardOrSheet
	| primCostume |

	primCostume := costume costume.

	primCostume contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := primCostume contents at: i.
		p :=cos player.
		p hasPlayer 
			ifFalse: [self addPlayer: p]
			ifTrue: [
				p player isComplexPlayer ifTrue: [
					self addPlayer: p player.
					p player attacheAllContentsTo: self].
			].
	].
! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 3/30/2006 16:01'!
close
	self resizeHandle ifNotNilDo: [:h | h close].
	super close.! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'mu 4/4/2006 17:26'!
coveredPlayers
	| col |
	col _ OrderedCollection new.
	self container elements
		do: [:aPlayer | 
			((aPlayer ~= self) 
				and: [self bounds containsRect: aPlayer bounds])
					ifTrue: [col add: aPlayer]].
	^ col! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 3/30/2006 15:51'!
destroy
	self resizeHandle ifNotNilDo: [:h | h destroy].
	super destroy.! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/3/2006 15:14'!
findParent
	| current |
	[(current := self container) notNil] whileTrue: [
		(current isKindOf: SqEventRecordBoard) ifTrue: [^ current].
		(current isKindOf: EToysWorld) ifTrue: [^ current].
	].

	^ nil! !

!SqSelectionPlayer methodsFor: 'grouping' stamp: 'minami 4/4/2006 11:24'!
group
	| covered |
	(covered := self coveredPlayers) size > 1
		ifTrue: [self addPlayers: covered].


	self removeResizeHandle! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 3/31/2006 15:40'!
onExtentChanged
	<on: #extentChanged>
! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 3/30/2006 15:48'!
onGeometryChanged
	<on: geometryChanged>

	self resizeHandle ifNotNilDo: [:h | h position: self bottomRight].! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 3/30/2006 15:54'!
onResizeHandleGeometryChanged
	self bounds: (self topLeft corner: resizeHandle position)! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 4/3/2006 14:54'!
onResizeHandleUp
	self resizeHandle close.! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 4/3/2006 14:20'!
onYellowButtonUp
	<on: yellowButtonUp>

	self selectionMenu open! !

!SqSelectionPlayer methodsFor: 'handle' stamp: 'minami 4/4/2006 11:08'!
removeResizeHandle
	self resizeHandle ifNotNil: [
		self resizeHandle close.
		self resizeHandle: nil.
	].! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 4/3/2006 15:36'!
resetAttachedPlayers
	self attachedPlayers: OrderedCollection new.! !

!SqSelectionPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 15:28'!
resizeHandle
	"Answer the resizeHandle of the receiver"
	<bewareOf: #resizeHandleChanged>
	^self propertyValueAt: #resizeHandle! !

!SqSelectionPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 15:28'!
resizeHandle: aValue
	"Modify the receiver's resizeHandle"
	^self propertyValueAt: #resizeHandle put: aValue with: #resizeHandleChanged! !

!SqSelectionPlayer methodsFor: 'menu' stamp: 'minami 4/3/2006 14:22'!
selectionMenu
	| menu |
	menu := CMenu new.
	self addGroupingMenuMenuOn: menu.
	^menu ! !

!SqSelectionPlayer methodsFor: 'grouping' stamp: 'minami 4/4/2006 11:20'!
ungroup
	| parent |
	parent := self findParent.

	attachedPlayers shallowCopy do: [:p |
		| newPos |
		newPos := p globalPosition - parent globalBounds topLeft.
		
		self remove: p.

		p position: newPos.
		parent add: p.
	].

	self resetAttachedPlayers.
	self destroy.
	! !

CPlayer subclass: #SqTabsHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabsHolder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
</fields>'!

!SqTabsHolder methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:21'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqTabsHolder methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:21'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqTabsHolder methodsFor: 'adding' stamp: 'minami 3/17/2006 12:05'!
addContent: aPlayer
	self contents add: aPlayer.

	self signal: #contentAdded with: aPlayer! !

!SqTabsHolder methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:28'!
close
	self activeContent ifNotNilDo: [:con | con close].
	self activeContent: nil.

	self contents do: [:aPlayer |
		aPlayer close.
	].
	self contents: OrderedCollection new.

	super close.! !

!SqTabsHolder methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:02'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!SqTabsHolder methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:02'!
contents: aValue
	"Modify the receiver's contents"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!SqTabsHolder methodsFor: 'initialize' stamp: 'mu 4/5/2006 11:13'!
defaultCostume
	^ SqTabsHolderCostume ! !

!SqTabsHolder methodsFor: 'initialize' stamp: 'minami 3/20/2006 11:22'!
initialize
	super initialize.
	
	activeContent := nil.
	contents := OrderedCollection new.
! !

CPlayer subclass: #SqTestPlayer
	instanceVariableNames: 'instVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

SqTestPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="instVar" toSet="instVar:">instVar</field>
</fields>'!

!SqTestPlayer methodsFor: 'initialization' stamp: 'MU 2/14/2006 14:31'!
initialize
	self color: Color red.
	self extent: 100@50.! !

!SqTestPlayer methodsFor: 'accessing' stamp: 'mu 3/7/2006 10:37'!
instVar
	"Answer the instVar of the receiver"
	^instVar! !

!SqTestPlayer methodsFor: 'accessing' stamp: 'mu 3/7/2006 10:37'!
instVar: aValue
	"Modify the receiver's instVar"
	instVar := aValue! !

!SqTestPlayer methodsFor: 'stepping' stamp: 'MU 2/14/2006 14:31'!
moveBy: anInteger
	self position: self position + anInteger! !

!SqTestPlayer methodsFor: 'stepping' stamp: 'MU 2/14/2006 14:28'!
start
	
	self startTicking: #moveBy: withArguments: #(1) at: 100! !

!Association methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:35'!
isAssociation
	^true! !

!SharedQueue2 class methodsFor: '*SqSquare-Core' stamp: 'mu 3/8/2006 11:10'!
new: initSize
	^self basicNew initialize: (OrderedCollection new: initSize)! !

!SharedQueue2 methodsFor: '*SqSquare-Core-initialization' stamp: 'mu 3/7/2006 17:08'!
initialize: itemCollection
	monitor _ Monitor new.
	items _ itemCollection
! !

!SharedQueue2 methodsFor: '*SqSquare-Core-releasing' stamp: 'mu 3/7/2006 17:04'!
release
	"all #next waiting processes will get nil"
	monitor defaultQueue size timesRepeat: [self nextPut: nil.]! !
SqSheetPlayer initialize!
SqPassiveConnection initialize!
SqImageId initialize!
SqPlayerEventFactory initialize!
SqLineConnector initialize!
SqUtil initialize!
SqMessage initialize!
SqSettings initialize!
